{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       Ancestor services form                          }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit diaser;

interface

uses
  SysUtils, Classes, rpibdb, ibdatabase,Db, QDialogs, QStdCtrls, QButtons,
  QControls,QForms;

type
  TFService = class(TForm)
    BOK: TButton;
    BCancel: TButton;
    OpenDialog1: TOpenDialog;
    Label3: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    Label6: TLabel;
    LAlias: TLabel;
    LProtocol: TLabel;
    EPassword: TEdit;
    EUsername: TEdit;
    BSearch: TBitBtn;
    EBase: TEdit;
    BCOnfig: TBitBtn;
    ComboAlias: TComboBox;
    EServer: TEdit;
    ComboProtocol: TComboBox;
    procedure BExaminarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BCOnfigClick(Sender: TObject);
    procedure ComboAliasClick(Sender: TObject);
    procedure BSearchClick(Sender: TObject);
    procedure EServerChange(Sender: TObject);
    procedure BOKClick(Sender: TObject);
    procedure EBaseChange(Sender: TObject);
    procedure ComboProtocolChange(Sender: TObject);
    procedure EUsernameChange(Sender: TObject);
    procedure EPasswordChange(Sender: TObject);
  private
    { Private declarations }
  protected
    procedure OnConChange(Sender:TObject);virtual;
  public
    { Public declarations }
    dbconf:TRpDBIBconf;
    username,password,server,database:string;
    protocol:TrpIBXProtocol;
    executed:boolean;
  end;


implementation


{$R *.xfm}


procedure TFService.BExaminarClick(Sender: TObject);
begin
 if Opendialog1.execute then
  EBase.text:=Opendialog1.filename;
end;

procedure TFService.FormShow(Sender: TObject);
begin
 if Assigned(dbconf) then
 begin
  LAlias.visible:=True;
  ComboAlias.visible:=true;
  BConfig.visible:=True;
  comboalias.Items.Assign(dbconf.databases);
 end;
 ComboProtocol.Itemindex:=0;
end;

procedure TFService.BCOnfigClick(Sender: TObject);
begin
 dbconf.ShowConfig(True,True,true);
 dbconf.LoadAliases;
 comboalias.Items.Assign(dbconf.databases);
 comboalias.itemindex:=-1;
end;

procedure TFService.ComboAliasClick(Sender: TObject);
var
 dbinfo:TRpDBIBinfo;
begin
 if Comboalias.itemindex<0 then
  exit;
 dbinfo:=dbconf.databases.items[comboalias.itemindex];
 EServer.text:=dbinfo.Server;
 EserverChange(Self);
 EBase.text:=dbinfo.Filename;
 EUsername.text:=dbinfo.username;
 EPassword.text:=dbinfo.password;
 ComboProtocol.Itemindex:=integer(dbinfo.protocol);
end;

procedure TFService.BSearchClick(Sender: TObject);
begin
 if opendialog1.execute then
  EBase.text:=opendialog1.filename;
end;

procedure TFService.EServerChange(Sender: TObject);
begin
 if Length(Trim(Eserver.Text))>0 then
 begin
  LProtocol.Visible:=True;
  ComboProtocol.Visible:=True;
 end
 else
 begin
  LProtocol.Visible:=False;
  ComboProtocol.Visible:=False;
 end;
 if Length(trim(EServer.text))>0 then
 begin
  BSearch.visible:=False;
 end
 else
 begin
  BSearch.visible:=EBase.visible;;
 end;
 OnCOnChange(Sender);
end;


procedure TFService.BOKClick(Sender: TObject);
begin
 executed:=True;
 server:=EServer.text;
 protocol:=TRpIBXPRotocol(comboprotocol.itemindex);
 username:=EUsername.text;
 database:=EBase.text;
 password:=EPassword.text;
end;

procedure TFService.OnConChange(Sender:TObject);
begin

end;


procedure TFService.EBaseChange(Sender: TObject);
begin
 OnCOnChange(Sender);
end;

procedure TFService.ComboProtocolChange(Sender: TObject);
begin
 OnCOnChange(Sender);
end;

procedure TFService.EUsernameChange(Sender: TObject);
begin
 OnCOnChange(Sender);
end;

procedure TFService.EPasswordChange(Sender: TObject);
begin
 OnCOnChange(Sender);

end;

end.
