{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       Add Field and alter field dialog                }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit fieldprop;

interface

uses Classes, QForms, QControls, QStdCtrls,
  Db, IBDatabase, IBSQL,SysUtils,variants,
  ibutil2,ibacconst,QDialogs,DBClient, QGrids, QDBGrids, QMask;

type
  TFFieldprop = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Label1: TLabel;
    EFieldname: TEdit;
    LArray: TLabel;
    LCheck: TLabel;
    LDefault: TLabel;
    Label8: TLabel;
    Label10: TLabel;
    LBaseType: TLabel;
    GChar: TGroupBox;
    Longitud: TLabel;
    Label15: TLabel;
    ELongchar: TMaskEdit;
    GNum: TGroupBox;
    Label14: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    wrweqr: TLabel;
    EDecimals: TMaskEdit;
    Eprecision: TMaskEdit;
    GBlob: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ESegLen: TMaskEdit;
    ESubtype: TMaskEdit;
    GOrdena: TGroupBox;
    Label11: TLabel;
    Lcoll: TLabel;
    ComboChar: TComboBox;
    ComboColl: TComboBox;
    GridArray: TDBGrid;
    ECheck: TEdit;
    EDefault: TEdit;
    ComboType: TComboBox;
    IBCustom: TIBSQL;
    tran1: TIBTransaction;
    DDimensions: TClientdataset;
    DDimensionsLowIndex: TIntegerField;
    DDimensionsHighIndex: TIntegerField;
    DataSource1: TDataSource;
    LDomain: TLabel;
    ComboDomain: TComboBox;
    LComputed: TLabel;
    LComputed2: TLabel;
    EComputed: TEdit;
    Label19: TLabel;
    ComboSyn: TComboBox;
    CheckNoNull: TCheckBox;
    LDomCheck: TLabel;
    EDomCheck: TEdit;
    LDomDefault: TLabel;
    EDomDefault: TEdit;
    procedure ComboTypeClick(Sender: TObject);
    procedure ComboCollDropDown(Sender: TObject);
    procedure ComboSynClick(Sender: TObject);
    procedure ComboDomainDropDown(Sender: TObject);
    procedure ComboDomainClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    readeddomains:boolean;
    aexternal:string;
    docreate:boolean;
    procedure Fillinfo;
    procedure FillInfoFordomain(dinfo:TIBDefDomain);
    function Obtainstringtype(onlytype:boolean):string;
    function buildsource:string;
    procedure CreateField;
  public
    { Public declarations }
    base:TIBDatabase;
    formodify:boolean;
    firstfield:boolean;
    newtable:boolean;
    table,field:string;
  end;

function ibmodifyfield(base:TIBDatabase;table,field:string):boolean;
function ibnewfield(base:TIBDatabase;table,field:string;firstfield:boolean;aexternal:string):boolean;

implementation

{$R *.xfm}

function ibmodifyfield(base:TIBDatabase;table,field:string):boolean;
var
 dia:TFFieldProp;
begin
 dia:=TFFieldProp.create(Application);
 try
  dia.tran1.defaultdatabase:=base;
  dia.IBCustom.database:=base;
  dia.base:=base;
  dia.table:=table;
  dia.field:=field;
  dia.HelpContext:=250;
  dia.gridarray.readonly:=True;
//  dia.gridarray.color:=clinfobk;
  if dia.base.sqldialect=3 then
  begin
   dia.ComboType.Items.Insert(6,'TIME');
   dia.ComboType.Items.Insert(7,'TIMESTAMP');
  end;
  dia.EFieldname.text:=field;
  dia.EFieldname.readonly:=True;
//  dia.EFieldname.color:=clinfobk;
  dia.ComboTypeclick(dia);
  dia.Fillinfo;
  dia.showmodal;
  Result:=dia.docreate;
 finally
  dia.free;
 end;
end;

function ibnewfield(base:TIBDatabase;table,field:string;firstfield:boolean;aexternal:string):boolean;
var
 dia:TFFieldProp;
begin
 dia:=TFFieldProp.create(Application);
 try
  dia.tran1.defaultdatabase:=base;
  dia.IBCustom.database:=base;
  dia.table:=table;
  dia.field:=field;
  dia.base:=base;
  dia.aexternal:=aexternal;
  dia.newtable:=firstfield;
  if dia.base.sqldialect=3 then
  begin
   dia.ComboType.Items.Insert(6,'TIME');
   dia.ComboType.Items.Insert(7,'TIMESTAMP');
  end;
  dia.ComboTypeclick(dia);
  dia.comboSyn.itemindex:=0;
  dia.EFieldname.text:=field;
  dia.COmboSynclick(dia);
  dia.showmodal;
  Result:=dia.docreate;
 finally
  dia.free;
 end;
end;

procedure TFFieldprop.ComboTypeClick(Sender: TObject);
begin
 GBlob.visible:=false;
 GOrdena.visible:=false;
 GNum.visible:=false;
 GChar.visible:=false;
 if ComboSyn.itemindex<>2 then
 begin
  GridArray.visible:=true;
  LArray.visible:=true;
 end;
 ComboChar.itemindex:=-1;
 ComboColl.itemindex:=-1;
 if base.sqldialect=1 then
 begin
  case ComboType.itemindex of
   6,7:
    begin
     GChar.visible:=true;
     GOrdena.visible:=true;
     LColl.Visible:=NOt formodify;
     ComboColl.visible:=not formodify;
     if (length(base.Params.Values['lc_ctype'])>0) then
      ComboChar.itemindex:=Combochar.Items.IndexOf(base.Params.Values['lc_ctype'])
     else
      ComboChar.itemindex:=0;
    end;
   8:
    begin
     GBlob.visible:=true;
     GOrdena.visible:=true;
     if (length(base.Params.Values['lc_ctype'])>0) then
      ComboChar.itemindex:=Combochar.Items.IndexOf(base.Params.Values['lc_ctype'])
     else
      ComboChar.itemindex:=0;
     LColl.Visible:=false;
     ComboColl.visible:=false;
     LArray.visible:=false;
     GridArray.visible:=false;
     DDimensions.Close;
     DDimensions.Createdataset;
    end;
   4:
    begin
     GNum.visible:=true;
    end;
  end;
 end
 else
 begin
  case ComboType.itemindex of
   8,9:
    begin
     GChar.visible:=true;
     GOrdena.visible:=true;
     LColl.Visible:=NOt formodify;
     ComboColl.visible:=not formodify;
     if (length(base.Params.Values['lc_ctype'])>0) then
      ComboChar.itemindex:=Combochar.Items.IndexOf(base.Params.Values['lc_ctype'])
     else
      ComboChar.itemindex:=0;
    end;
   10:
    begin
     GBlob.visible:=true;
     GOrdena.visible:=true;
     if (length(base.Params.Values['lc_ctype'])>0) then
      ComboChar.itemindex:=Combochar.Items.IndexOf(base.Params.Values['lc_ctype'])
     else
      ComboChar.itemindex:=0;
     LArray.visible:=false;
     GridArray.visible:=false;
     DDimensions.Close;
     DDimensions.Createdataset;
    end;
   4:
    begin
     GNum.visible:=true;
    end;
  end;
 end;
end;

procedure TFFieldprop.Fillinfo;
var
 finfo:TIBDeffield;
begin
 formodify:=True;
 // Search and assign new domain properties
 Caption:=SRpModifyfield;
 Checknonull.enabled:=false;
 finfo:=Fillfieldinfo(base,table,field,nil);
 if Length(finfo.defdomain.name)>0 then
 begin
  ComboSyn.itemindex:=1;
  ComboSynclick(Self);
  ComboDomainDropDown(Self);
  ComboDomain.itemindex:=combodomain.items.indexof(finfo.defdomain.name);
  ComboDomainClick(Self);
 end
 else
 begin
  ComboSyn.itemindex:=0;
 end;
 LCheck.visible:=Length(finfo.defdomain.check)>0;
 ECheck.visible:=Length(finfo.defdomain.check)>0;
 ECheck.text:=finfo.defdomain.check;
 ECheck.ReadOnly:=true;
// ECheck.color:=clinfoBK;
 LDefault.visible:=Length(finfo.default)>0;
 EDefault.visible:=Length(finfo.default)>0;
 EDefault.text:=finfo.default;
 EDefault.ReadOnly:=true;
// EDefault.color:=clinfoBK;
 LComputed.visible:=Length(finfo.computed)>0;
 EComputed.visible:=Length(finfo.computed)>0;
 EComputed.readonly:=True;
// EComputed.color:=clInfoBk;
 EComputed.text:=finfo.computed;
 if length(finfo.defdomain.name)>0 then
 begin
  if length(finfo.defdomain.character_set)>0 then
  begin
   ComboChar.itemindex:=Combochar.Items.IndexOf(finfo.defdomain.character_set);
  end;
  if finfo.defdomain.subtype<>null then
   ESubtype.text:=Inttostr(finfo.defdomain.subtype);
  if finfo.defdomain.segmentsize<>null then
   ESegLen.text:=Inttostr(finfo.defdomain.segmentsize);
  if finfo.defdomain.precision<>null then
   EPrecision.text:=Inttostr(finfo.defdomain.precision);
  if finfo.defdomain.scale<>null then
   EDecimals.text:=Inttostr(-finfo.defdomain.scale);
  ELongChar.text:=Inttostr(finfo.defdomain.size);
 end;
 DDimensions.readonly:=true;
// Gridarray.color:=clinfobk;
end;


procedure TFFieldprop.ComboCollDropDown(Sender: TObject);
var
 orderdef:string;
 charid:integer;
begin
 // Posibles collation orders
 ComboColl.items.clear;
 if ComboChar.Itemindex<0 then
  exit;
 if Tran1.InTransaction then
  Tran1.Rollback;
 tran1.StartTransaction;
 try
  charid:=1;
  IBCustom.Close;
  IBCustom.SQL.TExt:='SELECT RDB$CHARACTER_SET_ID CHARID,RDB$DEFAULT_COLLATE_NAME DEFCOL'+
   ' FROM RDB$CHARACTER_SETS WHERE RDB$CHARACTER_SET_NAME='''+
   combochar.items.strings[combochar.itemindex]+'''';
  IBCustom.ExecQuery;
  try
   If Not IBCustom.EOF then
   begin
    charid:=IBCustom.fieldbyname('CHARID').AsInteger;
    orderdef:=Trim(IBCustom.fieldbyname('DEFCOL').AsString);
   end
   else
    exit;
   IBCustom.close;
   IBCustom.sql.text:='SELECT RDB$COLLATION_NAME NOM '+
   ' FROM RDB$COLLATIONS WHERE RDB$CHARACTER_SET_ID='+
    inttostr(charid);
   IBCustom.execquery;
   While not IBCustom.eof do
   begin
    ComboColl.Items.Add(Trim(IBCustom.fieldbyname('NOM').AsString));
    IBCustom.next;
   end;
  finally
   IBCustom.close;
  end;
  tran1.commit;
 except
  tran1.rollback;
  raise;
 end;
end;

procedure TFFieldprop.ComboSynClick(Sender: TObject);
begin
 // Shows or hides the controls
 GOrdena.visible:=false;
 GBlob.visible:=false;
 GNum.visible:=false;
 GChar.visible:=false;
 LComputed.visible:=false;
 EComputed.visible:=false;
 LArray.visible:=False;
 Gridarray.visible:=false;
 LComputed.visible:=false;
 LComputed2.visible:=false;
 EComputed.visible:=false;
 LDomain.visible:=false;
 ComboDomain.visible:=false;
 LDomDefault.visible:=false;
 EDomDefault.visible:=false;
 LDomCheck.visible:=false;
 EDomCheck.visible:=false;
 ComboType.enabled:=False;
// ComboType.color:=clInfoBk;
 DDimensions.close;
 DDimensions.Createdataset;
 ComboChar.enabled:=false;
// Combochar.color:=clinfobk;
 ELongChar.readonly:=True;
// ELongchar.color:=clinfobk;
 ESubType.readonly:=True;
 ESegLen.readonly:=True;
// ESubType.color:=clinfobk;
// ESegLen.color:=clinfobk;
 EPrecision.readonly:=True;
 EDecimals.readonly:=True;
// EPrecision.color:=clinfobk;
// EDecimals.color:=clinfobk;
// Gridarray.color:=clInfoBk;
 Gridarray.readonly:=True;
 CheckNoNull.checked:=false;
 CheckNoNull.enabled:=False;

 Case ComboSyn.itemindex of
  0:
   begin
    ComboType.itemindex:=1;
//    Gridarray.color:=clWindow;
    Gridarray.readonly:=False;
    ComboType.enabled:=True;
//    ComboType.color:=clWindow;
    ComboChar.enabled:=True;
//    Combochar.color:=clWindow;
    ELongChar.readonly:=False;
//    ELongchar.color:=clWindow;
    ESubType.readonly:=False;
    ESegLen.readonly:=False;
//    ESubType.color:=clWindow;
//    ESegLen.color:=clWindow;
    EPrecision.readonly:=False;
    EDecimals.readonly:=False;
//    EPrecision.color:=clWindow;
//    EDecimals.color:=clWindow;
    CheckNoNull.enabled:=True;
    ComboTypeClick(Self);
   end;
  1:
   begin
    LDomain.visible:=True;
    ComboDomain.visible:=True;
    Combodomain.itemindex:=-1;
    ComboType.itemindex:=-1;
   end;
  2:
   begin
    ComboType.itemindex:=-1;
    LComputed.visible:=True;
    LComputed2.visible:=True;
    EComputed.visible:=True;
    ComboType.enabled:=True;
//    ComboType.color:=clWindow;
    ComboChar.enabled:=True;
//    Combochar.color:=clWindow;
    ELongChar.readonly:=False;
//    ELongchar.color:=clWindow;
    ESubType.readonly:=False;
    ESegLen.readonly:=False;
//    ESubType.color:=clWindow;
//    ESegLen.color:=clWindow;
    EPrecision.readonly:=False;
    EDecimals.readonly:=False;
//    EPrecision.color:=clWindow;
//    EDecimals.color:=clWindow;
    CheckNONull.enabled:=True;
   end;
 end;
end;

procedure TFFieldprop.ComboDomainDropDown(Sender: TObject);
begin
// SendMessage(ComboDomain.Handle,CB_SETDROPPEDWIDTH,256,0);
 // Read the domains
 if readeddomains then
  exit;
 ComboDomain.Items.clear;
 tran1.starttransaction;
 try
  IBCustom.sql.text:='SELECT RDB$FIELD_NAME '+
     ' FROM RDB$FIELDS '+
     ' WHERE ((RDB$SYSTEM_FLAG IS NULL) OR (RDB$SYSTEM_FLAG=0)) '+
//     ' WHERE (NOT (RDB$SYSTEM_NAME LIKE ''RDB$%'')) '+
     ' ORDER BY 1';
  IBCustom.ExecQuery;
  try
   While Not IBCustom.Eof do
   begin
    ComboDomain.items.add(Trim(IBCustom.FieldByName('RDB$FIELD_NAME').AsString));
    IBCustom.next;
   end;
  finally
   IBCustom.close;
  end;
  readeddomains:=True;
 finally
  tran1.rollback;
 end;
end;

procedure TFFieldprop.ComboDomainClick(Sender: TObject);
var
 defdom:TIBDefdomain;
begin
 // Selects the domain name gets the info and fills the
 // fields
 if combodomain.itemindex<0 then
  exit;
 defdom:=FillDomaininfo(base,combodomain.text,nil);
 FillInfoForDomain(defdom);
end;

procedure TFFieldprop.FillInfoFordomain(dinfo:TIBDefDomain);
var
 i:integer;
begin
 EDomCheck.Text:=dinfo.check;
 EDomDefault.text:=dinfo.default;
 LDomDefault.visible:=Length(dinfo.default)>0;
 EDomDefault.visible:=Length(dinfo.default)>0;
 LDomCheck.visible:=Length(dinfo.check)>0;
 EDomCheck.visible:=Length(dinfo.check)>0;
 if dinfo.Notnull then
 begin
  CheckNoNull.Checked:=true;
  CheckNoNull.enabled:=False;
 end
 else
 begin
  CheckNoNull.Checked:=false;
  CheckNoNull.enabled:=true;
 end;
 ComboType.itemindex:=ComboType.items.IndexOf(ibfieldtypetostringtype(dinfo.basetype,dinfo.scale,base.sqldialect));
 ComboTypeClick(Self);

 if length(dinfo.character_set)>0 then
 begin
  ComboChar.itemindex:=Combochar.Items.IndexOf(dinfo.character_set);
  if not formodify then
   Combocoll.text:=dinfo.collation;
 end;

 DDimensions.disablecontrols;
 try
  for i:=0 to dinfo.arraydimcount-1 do
  begin
   DDimensions.Append;
   try
    DDimensionsLowIndex.Value:=dinfo.arraydim[i].low;
    DDimensionsHighIndex.Value:=dinfo.arraydim[i].high;
    DDimensions.post;
   except
    DDimensions.cancel;
    raise;
   end;
  end;
 finally
  DDimensions.EnableControls;
 end;
 if dinfo.subtype<>null then
  ESubtype.text:=Inttostr(dinfo.subtype);
 if dinfo.segmentsize<>null then
  ESegLen.text:=Inttostr(dinfo.segmentsize);
 if dinfo.precision<>null then
  EPrecision.text:=Inttostr(dinfo.precision);
 if dinfo.scale<>null then
  EDecimals.text:=Inttostr(-dinfo.scale);
 ELongChar.text:=Inttostr(dinfo.size);
end;

function TFFieldprop.buildsource:string;
var
 fieldstring:string;
 adeli:string;
begin
 adeli:='';
 if base.sqldialect=3 then
  adeli:='"';
 DDimensions.CheckBrowseMode;
 // Check for the type
 if formodify then
  fieldstring:=' '
 else
  fieldstring:=adeli+EFieldName.text+adeli+' ';

 case comboSyn.itemindex of
  0:
   begin
    fieldstring:=fieldstring+ObtainStringType(false);
   end;
  1:
   begin
    if Length(Trim(Combodomain.text))<1 then
     Raise Exception.create(SRpSelectDomain);
    fieldstring:=fieldstring+ComboDomain.Text+' ';
   end;
  2:
   begin
    if Length(Trim(EComputed.text))<1 then
    begin
     EComputed.SetFocus;
     Raise Exception.create(SRpEnterComputed);
    end;
    if ComboType.itemindex>=0 then
    begin
     fieldstring:=fieldstring+ObtainStringType(false)+' ';
    end;
    fieldstring:=fieldstring+' COMPUTED BY '+EComputed.text+' ';
   end;
 end;

 if Length(Trim(EDefault.text))>0 then
  fieldstring:=fieldstring+' '+EDefault.text+#13+#10;
 if (CheckNoNull.checked AND CheckNoNull.Enabled) then
  fieldstring:=fieldstring+' NOT NULL'+#13+#10;
 if Length(Trim(ECheck.text))>0 then
  fieldstring:=fieldstring+' '+ECheck.text+#13+#10;
 if ( ((base.sqldialect=1) and (ComboType.ItemIndex in [6,7]))
      OR ((base.sqldialect<>1) and (ComboType.ItemIndex in [8,9])) )then
 begin
  if Length(Trim(COmboColl.text))>0 then
   fieldstring:=fieldstring+' COLLATE '+ComboColl.text;
 end;
 Result:=fieldstring;
end;

function TFFieldProp.Obtainstringtype(onlytype:boolean):string;
var
 astring:string;
begin
 Result:=ComboType.items.strings[ComboType.itemindex];
 if base.sqldialect=1 then
 begin
  case ComboType.itemindex of
   6,7:
    Result:=Result+'('+IntToStr(StrToInt(ELongchar.Text))+')';
   4:
    Result:=Result+'('+IntToStr(StrToInt(Eprecision.Text))+','+inttostr(StrToInt(EDecimals.Text))+')';
  end;
 end
 else
 begin
  case ComboType.itemindex of
   8,9:
    Result:=Result+'('+IntToStr(StrToInt(ELongchar.Text))+')';
   4:
    Result:=Result+'('+IntToStr(StrToInt(Eprecision.Text))+','+inttostr(StrToINt(EDecimals.Text))+')';
  end;
 end;
 if Not onlytype then
 begin
  // Add the dimensions
  DDimensions.first;
  if Not DDimensions.eof then
  begin
   astring:='[';
   While Not DDimensions.EOF do
   begin
    astring:=astring+DDimensionsLowIndex.AsString+':'+
     DDimensionsHighIndex.AsString;
    DDimensions.next;
    if Not DDimensions.EOF then
     astring:=astring+',';
   end;
   astring:=astring+']';
  end;
  Result:=Result+astring;
 end;
 if ( ((base.sqldialect=1) and (ComboType.ItemIndex in [6,7]))
      OR ((base.sqldialect<>1) and (ComboType.ItemIndex in [8,9])) )then
 begin
  Result:=Result+' CHARACTER SET '+ComboChar.text;
 end;
 if  (  ((base.sqldialect=1) AND (ComboType.ItemIndex=8)) OR
     ((base.sqldialect<>1) AND (ComboType.ItemIndex=10)) )
    then
 begin
  Result:=Result+' SUB_TYPE '+IntTostr(StrToInt(ESubTYpe.Text))+' SEGMENT SIZE '+IntTostr(StrToInt(ESegLen.Text));
  if (StrToInt(ESubTYpe.Text)=1) then
   Result:=Result+' CHARACTER SET '+ComboChar.text;
 end;
{ if onlytype then
 begin
  if ( ((base.sqldialect=1) and (ComboType.ItemIndex in [6,7]))
       OR ((base.sqldialect<>1) and (ComboType.ItemIndex in [8,9])) )then
  begin
   Result:=Result+' COLLATE '+ComboColl.text;
  end;
 end;
}end;

procedure TFFieldprop.OKBtnClick(Sender: TObject);
begin
 CreateField;
 docreate:=true;
 Close;
end;

procedure TFFieldProp.CreateField;
var
 astring:string;
 adeli:string;
begin
 adeli:='';
 if base.sqldialect=3 then
  adeli:='"';
 // Creates the field
 if newtable then
 begin
  astring:='CREATE TABLE '+adeli+table+adeli;
  if Length(Trim(aexternal))>0 then
   astring:=astring+' EXTERNAL '+Quotedstr(aexternal);
  astring:=astring+' ( '+buildsource+' ) ';
 end
 else
 begin
  astring:='ALTER TABLE '+adeli+table+adeli;
  if formodify then
   astring:=astring+' ALTER COLUMN '+adeli+field+adeli+' TYPE '+buildsource
  else
   astring:=astring+' ADD '+buildsource;
 end;
// ShowMessage(astring);
 tran1.StartTransaction;
 try
  IBCustom.sql.text:=astring;
  IBCustom.ExecQuery;
  Tran1.Commit;
 except
  Tran1.rollback;
  Raise;
 end;
end;

procedure TFFieldprop.FormShow(Sender: TObject);
begin
 if Not formodify then
  exit;
 ComboSyn.items.Delete(2);
end;

procedure TFFieldprop.FormCreate(Sender: TObject);
begin
 DDimensions.Close;
 DDimensions.Createdataset;
end;

end.
