{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       ExecSQL Form                                    }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit ibexecsql;

interface

uses
  SysUtils, Classes,variants,
  IBDatabase,QDialogs,
  Db, IBCustomDataSet, IBQuery,
  IBSQL, IBDatabaseInfo,ibacconst,ibacutils,inifiles,
{$IFDEF LINUX}
  Libc,
{$ENDIF}
{$IFDEF WINDOWS}
  mmsystem,
{$ENDIF}
  rpshfolder,ibheader, DBClient, QMenus, QTypes, QActnList,
  QExtCtrls, QStdCtrls, QGrids, QDBGrids, QComCtrls, QControls, QForms,
  Qt, QImgList,dateutils;


const
 CMAX_SENTENCIES=50;
type
  TExecsqlprefsitems=(fspfastq,fspbidiq,
   fspshowstat,fspqplan,fspsaveh,fspcommitddl,fspparamcheck);
  TExecsqlprefs=set of TExecsqlprefsitems;

  TFExecSQL = class(TForm)
    BarraNav: TToolBar;
    ToolButton11: TToolButton;
    BBegin: TToolButton;
    ToolButton12: TToolButton;
    BAceptar: TToolButton;
    ToolButton13: TToolButton;
    BCancel: TToolButton;
    ToolButton14: TToolButton;
    BPred: TToolButton;
    BSuc: TToolButton;
    ToolButton15: TToolButton;
    BExec: TToolButton;
    ActionList1: TActionList;
    ANewtrans: TAction;
    ACommit: TAction;
    ARollback: TAction;
    ATranops: TAction;
    Trans: TIBTransaction;
    APrior: TAction;
    ANext: TAction;
    AExecute: TAction;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ScrollBox1: TScrollBox;
    Split: TSplitter;
    IBQuery1: TIBQuery;
    SQuery1: TDataSource;
    ABidirectional: TAction;
    PCOntrol: TPageControl;
    TabData: TTabSheet;
    DBGrid1: TDBGrid;
    TabStat: TTabSheet;
    IBSQL1: TIBSQL;
    AQueryPlan: TAction;
    MainMenu1: TMainMenu;
    Preferences1: TMenuItem;
    Bidirectionalquerys1: TMenuItem;
    Queryplan1: TMenuItem;
    MStat: TScrollBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    IBInfo: TIBDatabaseInfo;
    AStatistics: TAction;
    LReads: TLabel;
    Showstatistics1: TMenuItem;
    LIndexReads: TLabel;
    LSeqReads: TLabel;
    Label4: TLabel;
    Lfetches: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    LDeletions: TLabel;
    LUpdates: TLabel;
    LWrites: TLabel;
    Label9: TLabel;
    Linserts: TLabel;
    Label10: TLabel;
    LPurges: TLabel;
    LMarks: TLabel;
    SQL1: TMenuItem;
    Newtransaction1: TMenuItem;
    ACommit1: TMenuItem;
    Rollback1: TMenuItem;
    N1: TMenuItem;
    Transactionoptions1: TMenuItem;
    N2: TMenuItem;
    Prior1: TMenuItem;
    Next1: TMenuItem;
    ASaveHistory: TAction;
    SaveHistory1: TMenuItem;
    Transaction1: TMenuItem;
    Execute1: TMenuItem;
    LExpunges: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    LBackout: TLabel;
    AFastQuerys: TAction;
    DMEm: TClientDataset;
    AProgInterval100: TAction;
    AProgInterval10: TAction;
    AProgInterval1: TAction;
    Progresinterval1: TMenuItem;
    N1001: TMenuItem;
    N101: TMenuItem;
    N11: TMenuItem;
    Commit1: TMenuItem;
    TabPlan: TTabSheet;
    MPlan: TMemo;
    Panel1: TPanel;
    Label11: TLabel;
    LRows: TLabel;
    Label14: TLabel;
    LTime: TLabel;
    AClearBuffer: TAction;
    N3: TMenuItem;
    Clearhistory1: TMenuItem;
    ACommitddl: TAction;
    CommitDDL1: TMenuItem;
    ACommitret: TAction;
    Commitretaining1: TMenuItem;
    AParams: TAction;
    Parameters1: TMenuItem;
    ToolButton3: TToolButton;
    MEdit: TMemo;
    IconImages: TImageList;
    Aparamcheck: TAction;
    Paramcheck1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ANewtransExecute(Sender: TObject);
    procedure ACommitExecute(Sender: TObject);
    procedure ARollbackExecute(Sender: TObject);
    procedure ATranopsExecute(Sender: TObject);
    procedure AExecuteExecute(Sender: TObject);
    procedure AQueryPlanExecute(Sender: TObject);
    procedure ABidirectionalExecute(Sender: TObject);
    procedure AStatisticsExecute(Sender: TObject);
    procedure DBGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ASaveHistoryExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure APriorExecute(Sender: TObject);
    procedure ANextExecute(Sender: TObject);
    procedure AProgInterval100Execute(Sender: TObject);
    procedure AProgInterval10Execute(Sender: TObject);
    procedure AProgInterval1Execute(Sender: TObject);
    procedure AFastQuerysExecute(Sender: TObject);
    procedure AClearBufferExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ACommitddlExecute(Sender: TObject);
    procedure ACommitretExecute(Sender: TObject);
    procedure AParamsExecute(Sender: TObject);
    procedure DBGrid1EditButtonClick(Sender: TObject);
    procedure AparamcheckExecute(Sender: TObject);
  private
    { Private declarations }
    totalreads,totalwrites:int64;
    totalseqreads,totalidxreads:int64;
    totalfetches,totalpurges:int64;
    totalupdates,totalbackouts:int64;
    totaldeletions,totalmarks:int64;
    totalinserts,totalexpunges:int64;
    reads,writes:int64;
    seqreads,idxreads:int64;
    fetches,purges:int64;
    updates,bakouts:int64;
    deletions,marks:int64;
    inserts,expunges:int64;
    sentences:Tlist;
    sentenceindex:integer;
{$IFDEF WINDOWS}
    mmfirst,mmlast:DWORD;
{$ENDIF}
{$IFDEF LINUX}
    milifirst,mililast:TDatetime;
{$ENDIF}
    prog_interval:integer;
    procedure Golastrecord(Dia:TFFetching);
    procedure Fetchrecords(Dia:TFFetching);
    procedure EndFetch;
    procedure Endlastrecord;
    procedure Updatestatistics;
    procedure Readstatistics;
    procedure GetTime;
    procedure Updatetime;
    procedure DoBlobColumns;
  public
    { Public declarations }
    base:TIBDatabase;
    isdestroying:boolean;
    procedure SaveHistory;
    procedure LoadHistory;
  end;


implementation

uses mainform, ibtranop, rpparamdef, rpviewblob;

{$R *.xfm}

procedure TFExecSQL.FormClose(Sender: TObject; var Action: TCloseAction);
var
 i:integer;
begin
 Action:=cafree;
 if fmain.DWindows.Locate('WINDOW',integer(Self),[]) then
  fmain.DWindows.delete;
 // Try to save the history
 try
  if ASaveHistory.checked then
   SaveHistory;
 except
  On e:Exception do
  begin
   Messagedlg(E.message,mterror,[mbok],0);
  end;
 end;
 try
  ibsql1.close;
 except
  On e:Exception do
  begin
   Messagedlg(E.message,mterror,[mbok],0);
  end;
 end;
 try
  ibquery1.active:=false;
 except
  On e:Exception do
  begin
   Messagedlg(E.message,mterror,[mbok],0);
  end;
 end;
 try
  trans.active:=false;
 except
  On e:Exception do
  begin
   Messagedlg(E.message,mterror,[mbok],0);
  end;
 end;
 for i:=0 to sentences.count-1 do
 begin
  TStringlist(sentences.items[i]).free;
 end;
 sentences.free;
 isdestroying:=true;
end;


procedure TFExecSQL.ANewtransExecute(Sender: TObject);
begin
 Trans.StartTransaction;
 ACommit.Enabled:=true;
 ACommitret.Enabled:=true;
 ARollback.enabled:=true;
 ANewtrans.enabled:=False;
 ATranops.enabled:=False;
end;

procedure TFExecSQL.ACommitExecute(Sender: TObject);
begin
 Trans.commit;
 ARollback.enabled:=false;
 ACommitret.enabled:=false;
 ACommit.enabled:=false;
 ANewtrans.enabled:=true;
 ATranops.enabled:=true;
end;

procedure TFExecSQL.ARollbackExecute(Sender: TObject);
begin
 Trans.Rollback;
 ARollback.enabled:=false;
 ACommit.enabled:=false;
 Acommitret.enabled:=false;
 ANewtrans.enabled:=true;
 ATranops.enabled:=True;
end;

procedure TFExecSQL.ATranopsExecute(Sender: TObject);
begin
 IBModifyTransaction(Trans,fmain.dblist);
end;


function AddStringValues(list:TStrings):int64;
var
 i:integer;
 index:integer;
begin
 try
  Result:=0;
  for i:=0 to list.count-1 do
  begin
   index:=Pos('=',list.strings[i]);
   if index>0 then
    Result:=Result+StrToInt(Copy(list.strings[i],index+1,255));
  end;
 except
  Result:=0;
 end;
end;


procedure TFExecSQL.Readstatistics;
begin
 IBInfo.database:=base;
 totalreads:=IBInfo.Reads;
 totalwrites:=IBInfo.Writes;
 totalfetches:=IBInfo.Fetches;
 totalmarks:=IBInfo.Marks;
 totalseqreads:=AddStringValues(IBInfo.ReadSeqCount);
 totalidxreads:=AddStringValues(IBInfo.ReadIdxCount);
 totalpurges:=AddStringValues(IBInfo.purgecount);
 totalexpunges:=AddStringValues(IBInfo.expungecount);
 totalupdates:=AddStringValues(IBInfo.updatecount);
 totaldeletions:=AddStringValues(IBInfo.deletecount);
 totalinserts:=AddStringValues(IBInfo.InsertCount);
 totalbackouts:=AddStringValues(IBInfo.BackoutCount);
end;

procedure TFExecSQL.Updatestatistics;
var
 temp:int64;
begin
  reads:=IBINfo.reads-totalreads;
  totalreads:=IBINfo.reads;
  Lreads.caption:=Formatfloat('##,0.##',Reads);

  writes:=IBINfo.writes-totalwrites;
  totalwrites:=IBINfo.writes;
  LWrites.caption:=Formatfloat('##,0.##',Writes);

  marks:=IBINfo.marks-totalmarks;
  totalmarks:=IBINfo.marks;
  LMarks.caption:=Formatfloat('##,0.##',marks);

  fetches:=IBINfo.fetches-totalfetches;
  totalfetches:=IBINfo.fetches;
  LFetches.caption:=Formatfloat('##,0.##',fetches);

  // Seq reads
  temp:=AddStringValues(IBInfo.ReadSeqCount);
  seqreads:=temp-totalseqreads;
  totalseqreads:=temp;
  LSeqreads.caption:=Formatfloat('##,0.##',seqreads);

  // Idx reads
  temp:=AddStringValues(IBInfo.ReadIdxCount);
  idxreads:=temp-totalidxreads;
  totalidxreads:=temp;
  LIndexreads.caption:=Formatfloat('##,0.##',idxreads);

  // Updates
  temp:=AddStringValues(IBInfo.UpdateCount);
  updates:=temp-totalupdates;
  totalupdates:=temp;
  LUpdates.caption:=Formatfloat('##,0.##',updates);

  // Inserts
  temp:=AddStringValues(IBInfo.InsertCount);
  inserts:=temp-totalinserts;
  totalinserts:=temp;
  LInserts.caption:=Formatfloat('##,0.##',inserts);

  // Deletions
  temp:=AddStringValues(IBInfo.DeleteCount);
  deletions:=temp-totaldeletions;
  totaldeletions:=temp;
  LDeletions.caption:=Formatfloat('##,0.##',deletions);


  // Expunges
  temp:=AddStringValues(IBInfo.Expungecount);
  expunges:=temp-totalexpunges;
  totalexpunges:=temp;
  LExpunges.caption:=Formatfloat('##,0.##',expunges);

    // Backouts
  temp:=AddStringValues(IBInfo.Backoutcount);
  bakouts:=temp-totalbackouts;
  totalbackouts:=temp;
  LBackout.caption:=Formatfloat('##,0.##',bakouts);

  // Purges
  temp:=AddStringValues(IBInfo.Purgecount);
  purges:=temp-totalpurges;
  totalpurges:=temp;
  LPurges.caption:=Formatfloat('##,0.##',purges);
end;


procedure TFExecSQL.GetTime;
begin
 // Get the time
{$IFDEF WINDOWS}
 mmfirst:=TimeGetTime;
{$ENDIF}
{$IFDEF LINUX}
 milifirst:=now;
{$ENDIF}
end;

procedure TFExecSQL.Updatetime;
var
 sec:integer;
 milis:integer;
 mins,hours:integer;
 difmilis:int64;
 astring:string;
begin
{$IFDEF WINDOWS}
 mmlast:=TimeGetTime;
 difmilis:=(mmlast-mmfirst);
{$ENDIF}
{$IFDEF LINUX}
  mililast:=now;
  difmilis:=MillisecondsBetween(mililast,milifirst);
{$ENDIF}

 sec:=difmilis div 1000;
 mins:=sec div 60;
 sec:=sec mod 60;
 hours:=mins div 60;
 mins:=mins mod 60;
 milis:=difmilis mod 1000;
 astring:='';
 if hours>0 then
  astring:=astring+Formatfloat('##,0',hours)+' h. ';
 if mins>0 then
  astring:=astring+Formatfloat('##,0',mins)+' m. ';
 LTime.caption:=astring+Formatfloat('##,0',sec)+' s. '+Formatfloat('###',milis)+' ms.';
end;

procedure TFExecSQL.AExecuteExecute(Sender: TObject);
var
 l:tstringlist;
 equals:boolean;
 i:integer;
 fdef:TFielddef;
 ascaled:boolean;
 scale:integer;
 autocommit:boolean;


  procedure GetSelectedText;
  begin
    IBSQL1.SQL.Clear;
    IBSQL1.SQL.Add(MEdit.SelText);
  end;

begin
 autocommit:=false;
 // Executes the sql
 IBQuery1.database:=base;
 IBSQL1.database:=base;
 Trans.defaultdatabase:=base;
 if Not ACommit.enabled then
 begin
  ANewtrans.Execute;
 end;
 IBQuery1.close;
 IBSQL1.close;
 DMem.close;
 DBGrid1.visible:=false;
 if IBSQL1.sql.text<>MEdit.Text then
  IBSQL1.sql.text:=MEdit.Text;
 MPlan.Text:='';
 if AQueryPlan.checked then
 begin
  IBSQL1.Prepare;
  MPlan.text:=IBSQL1.Plan;
 end;
 if AStatistics.checked then
 begin
  ReadStatistics;
 end;
 if AFastquerys.checked then
 begin
  if AQueryplan.checked then
   GetTime;
  // Autocommit?
  if (IBSQL1.SQLType=SQLDDL) then
   if ACommitddl.checked then
    Autocommit:=true;
  // Checkparams?
  IBSQL1.ParamCheck:=AParamcheck.checked;
  IBSQL1.ExecQuery;
  if AQueryplan.checked then
   Updatetime;
  SQuery1.dataset:=DMem;
  if (IBSQL1.Open) then
  begin
   dmem.fielddefs.Clear;
   for i:=0 to IBSQL1.Current.Count-1 do
   begin
    ascaled:=IBSQL1.current.Vars[i].AsXSQLVAR^.sqlscale<>0;
    scale:=IBSQL1.current.Vars[i].AsXSQLVAR^.sqlscale;
    fdef:=DMem.Fielddefs.AddFieldDef;
    with IBSQL1.current.Vars[i] do
    begin
     fdef.DisplayName:=Name;
     case SQLType of
      SQL_VARYING,SQL_Text:
       begin
        fdef.DataType:=ftstring;
        fdef.Size:=Size;
       end;
      SQL_DOUBLE,SQL_FLOAT,SQL_D_FLOAT:
       begin
        if aScaled then
         fdef.DataType:=ftCurrency
        else
         fdef.datatype:=ftfloat;
       end;
      SQL_LONG,SQL_QUAD:
       begin
        if aScaled then
         fdef.DataType:=ftCurrency
        else
         fdef.datatype:=ftInteger;
       end;
      SQL_SHORT:
       begin
        if aScaled then
         fdef.DataType:=ftCurrency
        else
         fdef.datatype:=ftInteger;
       end;
      SQL_TIMESTAMP:
       begin
        fdef.DataType:=ftDateTime;
       end;
      SQL_BLOB:
       begin
        if data^.sqlsubtype=1 then
         fdef.DataType:=ftMemo
        else
         fdef.DataType:=ftblob;
       end;
      SQL_ARRAY:
       begin
        fdef.DataType:=ftArray;
       end;
      SQL_TYPE_TIME:
       begin
        fdef.DataType:=ftTime;
       end;
      SQL_TYPE_DATE:
       begin
        fdef.DataType:=ftDate;
       end;
      SQL_INT64:
       begin
        if aScaled then
        begin
         if scale>=-4 then
          fdef.DataType:=ftCurrency
         else
          fdef.datatype:=ftLargeint;
        end
        else
         fdef.datatype:=ftLargeint;
       end;
     end;
    end;
   end;
   DMem.CreateDataSet;
   for i:=0 to dmem.fieldcount-1 do
   begin
    if dmem.fields[i].DataType=ftCurrency then
     TCurrencyField(dmem.fields[i]).Currency:=false;
   end;
   ExecuteActionProgres(Fetchrecords,true,EndFetch);
   DoBlobColumns;
   DBGrid1.visible:=True;
  end;
 end
 else
 begin
  IBSQL1.SQL.Text:='';
  IBQuery1.Close;
  SQuery1.dataset:=IBQuery1;
  IBQuery1.sql.text:=MEdit.Text;
  IBQuery1.disablecontrols;
  try
   if AQueryplan.checked then
    GetTime;
   IBQuery1.ParamCheck:=AParamcheck.checked;
   IBQuery1.Prepare;
   if (IBQuery1.StatementType=SQLDDL) then
    if ACommitddl.checked then
     Autocommit:=true;
   IBQuery1.Open;
   if AQueryplan.checked then
    Updatetime;
  finally
   IBQuery1.enablecontrols;
  end;
 end;
 if AStatistics.Checked then
 begin
  UpdateSTatistics;
 end;
 if AFastquerys.checked then
 begin
  if (Not DMem.Active) then
   DBGrid1.visible:=false
  else
  begin
   DoBlobColumns;
   DBGrid1.visible:=true;
  end;
 end
 else
 begin
  if IBQuery1.Fieldcount<=0 then
  begin
   IBQuery1.close;
   DBGrid1.visible:=false;
  end
  else
  begin
   DoBlobColumns;
   DBGrid1.visible:=true;
  end;
 end;

 // Rows affected
 if AQueryPlan.Checked then
 begin
  // Rows
  if AFastQuerys.checked then
  begin
   if IBSQL1.RowsAffected>0 then
    LRows.caption:=Formatfloat('##,0.##',IBSQL1.RowsAffected)
   else
    LRows.caption:='';
  end
  else
  begin
   if IBQuery1.RowsAffected>0 then
    LRows.caption:=Formatfloat('##,0.##',IBQuery1.RowsAffected)
   else
    LRows.caption:='';
  end;
 end;
 // Auto Commit
 if autocommit then
  ACommit.execute;

 // History
 equals:=false;
 if sentences.count>0 then
 begin
  l:=TStringlist(sentences.items[sentences.count-1]);
  if l.text=MEdit.text then
   equals:=true;
 end;
 if not equals then
 begin
  l:=TStringlist.create;
  l.text:=MEdit.text;
  sentences.add(l);
  if sentences.count>CMAX_SENTENCIES then
   sentences.delete(0);
 end;
 sentenceindex:=sentences.count;
 APrior.enabled:=true;
 ANext.enabled:=false;
end;

procedure TFExecSQL.Golastrecord(Dia:TFFetching);
var
 counter:integer;
begin
 counter:=0;
 While Not IBQuery1.EOF do
 begin
  IBQuery1.Next;
  inc(counter);
  if (counter mod PROG_INTERVAL)=0 then
  begin
   dia.IncFetch(PROG_INTERVAL);
  end;
 end;
end;

procedure TFExecSQL.Endlastrecord;
begin
 IBQuery1.enablecontrols;
end;

procedure TFExecSQL.AQueryPlanExecute(Sender: TObject);
begin
 AQueryplan.checked:=Not AQueryPlan.Checked;
 TabPlan.Tabvisible:=AQueryPlan.Checked;
 if Not TabPlan.Tabvisible then
  PControl.activepage:=TabData;
end;

procedure TFExecSQL.ABidirectionalExecute(Sender: TObject);
begin
 ABidirectional.checked:=Not ABidirectional.checked;
 IBQuery1.close;
 IBQuery1.UniDirectional:=Not ABidirectional.checked;
end;

procedure TFExecSQL.AStatisticsExecute(Sender: TObject);
begin
 AStatistics.Checked:=Not AStatistics.Checked;
 TabStat.Tabvisible:=AStatistics.Checked;
 if Not TabStat.Tabvisible then
  PControl.activepage:=TabData;
end;

procedure TFExecSQL.DBGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (KEY=Key_END) and (ssCtrl in Shift) then
 begin
  if SQuery1.dataset=IBQuery1 then
  begin
   Key:=0;
   IBQuery1.disablecontrols;
   ExecuteActionProgres(GoLastrecord,true,EndLastRecord);
  end;
 end;
end;

procedure TFExecSQL.ASaveHistoryExecute(Sender: TObject);
begin
 ASaveHistory.checked:=Not ASaveHistory.Checked;
end;

procedure TFExecSQL.FormCreate(Sender: TObject);
begin
 AExecute.ShortCut:=ShortCut(Key_RETURN,[ssAlt]);
 Acommit.shortcut:=ShortCut(Key_RETURN,[ssCtrl]);
 ARollback.shortcut:=ShortCut(Key_BACKSPACE,[ssCtrl]);
 APrior.shortcut:=ShortCut(Key_LEFT,[ssAlt]);
 ANext.shortcut:=ShortCut(Key_RIGHT,[ssAlt]);
 sentences:=TList.create;
 sentenceindex:=0;
 Height:=335;
 prog_interval:=100;
 TabStat.tabvisible:=false;
 // Reads the prefrences from main form
 with fmain do
 begin
  if Not (fspfastq in execsqlprefs) then
   AFastQuerys.Execute;
  if Not (fspparamcheck in execsqlprefs) then
   AParamCheck.Execute;
  if Not (fspbidiq in execsqlprefs) then
   ABidirectional.Execute;
  if (fspshowstat in execsqlprefs) then
   Self.AStatistics.execute;
  if Not (fspqplan in execsqlprefs) then
   AQueryPlan.execute;
  if Not (fspsaveh in execsqlprefs) then
   ASaveHistory.execute;
  if Not (fspcommitddl in execsqlprefs) then
   ACommit.execute;
 end;
end;


procedure TFExecSQL.APriorExecute(Sender: TObject);
begin
 dec(sentenceindex);
 if sentenceindex<1 then
 begin
  sentenceindex:=0;
  APrior.enabled:=false;
 end;
 MEdit.Text:=TStringList(sentences.items[sentenceindex]).Text;
 ANext.enabled:=true;
end;

procedure TFExecSQL.ANextExecute(Sender: TObject);
begin
 inc(sentenceindex);
 if sentenceindex>(sentences.count-1) then
 begin
  sentenceindex:=sentences.count;
  MEdit.Text:='';
  ANext.enabled:=false;
 end
 else
 begin
  MEdit.Text:=TStringList(sentences.items[sentenceindex]).Text;
 end;
 APrior.enabled:=(sentenceindex>0);
end;

procedure TFExecSQL.SaveHistory;
var
 inif:TInifile;
 ininame:string;
 i,j:integer;
 s:TStrings;
begin
 ininame:=Obtainininameuserconfig('','ibaccess','history');
 inif:=TInifile.create(ininame);
 try
  inif.WriteInteger(base.DatabaseName,'ProgInterval',prog_interval);
  inif.WriteInteger(base.DatabaseName,'Histcount',sentences.count);
  for i:=0 to sentences.count-1 do
  begin
   s:=TStringlist(sentences.Items[i]);
   inif.WriteInteger(base.DatabaseName,'Histlcount'+inttostr(i),s.count);
   for j:=0 to s.count-1 do
   begin
    inif.WriteString(base.databasename,'Hist'+inttostr(i)+'-'+inttostr(j),s[j]);
   end;
  end;
  inif.UpdateFile;
 finally
  inif.free;
 end;
end;

procedure TFExecSQL.LoadHistory;
var
 inif:TInifile;
 ininame:string;
 i,j,icount,lcount:integer;
 l:TStringlist;
 astring:string;
begin
 ininame:=Obtainininameuserconfig('','ibaccess','history');
 inif:=TInifile.create(ininame);
 try
  prog_interval:=inif.ReadInteger(base.DatabaseName,'ProgInterval',100);
  case prog_interval of
   100:
    AprogInterval100.Execute;
   10:
    AprogInterval10.Execute;
   1:
    AprogInterval1.Execute;
  end;
  icount:=inif.ReadInteger(base.DatabaseName,'Histcount',0);
  if icount>CMAX_SENTENCIES then
   icount:=CMAX_SENTENCIES;
  for i:=0 to icount-1 do
  begin
   l:=TStringlist.create;
   try
    lcount:=inif.ReadInteger(base.DatabaseName,'Histlcount'+inttostr(i),0);
    for j:=0 to lcount-1 do
    begin
     astring:=inif.ReadString(base.databasename,'Hist'+inttostr(i)+'-'+inttostr(j),'');
     l.add(astring);
    end;
   except
    l.free;
    raise;
   end;
   sentences.add(l);
  end;
  sentenceindex:=icount-1;
  if sentenceindex<0 then
   sentenceindex:=0
  else
  begin
   ANext.enabled:=true;
   ANext.Execute;
  end;
 finally
  inif.free;
 end;
end;

procedure TFExecSQL.Fetchrecords(Dia:TFFetching);
var
 counter:integer;

procedure Addrecord;
var
 i:integer;
 stream:TStream;
begin
 DMem.Append;
 try
  for i:=0 to dmem.FieldCount-1 do
  begin
   if dmem.Fields[i].DataType in [ftblob,ftmemo] then
   begin
    if  IBSQL1.fields[i].isnull then
     dmem.fields[i].asvariant:=null
    else
    begin
     Stream:=dmem.CreateBlobStream(dmem.fields[i],bmwrite);
     try
      IBSQL1.Fields[i].SaveToStream(stream);
     finally
      stream.free;
     end;
    end;
   end
   else
   begin
    if (dmem.Fields[i].DataType=ftLargeInt) then
    begin
     TLargeIntField(dmem.Fields[i]).AsLargeInt:=IBSQL1.Fields[i].AsInt64;
    end
    else
     dmem.Fields[i].AsVariant:=IBSQL1.Fields[i].AsVariant;
   end;
  end;
  DMem.Post;
 except
  DMem.cancel;
  raise;
 end;
end;

begin
 DMem.disablecontrols;
 try
  counter:=0;
  While Not IBSQL1.EOF do
  begin
   inc(counter);
   if (counter mod PROG_INTERVAL)=0 then
   begin
    dia.IncFetch(PROG_INTERVAL);
   end;
   AddRecord;
   IBSQL1.Next;
  end;
  DMem.First;
 finally
  dmem.enablecontrols;
 end;
end;

procedure TFExecSQL.EndFetch;
begin
 IBSQL1.Close;
end;


procedure TFExecSQL.AProgInterval100Execute(Sender: TObject);
begin
 AprogInterval100.checked:=True;
 AprogInterval10.checked:=False;
 AprogInterval1.checked:=False;
 prog_interval:=100;
end;

procedure TFExecSQL.AProgInterval10Execute(Sender: TObject);
begin
 AprogInterval100.checked:=False;
 AprogInterval10.checked:=True;
 AprogInterval1.checked:=True;
 prog_interval:=10;
end;

procedure TFExecSQL.AProgInterval1Execute(Sender: TObject);
begin
 AprogInterval100.checked:=False;
 AprogInterval10.checked:=False;
 AprogInterval1.checked:=True;
 prog_interval:=1;
end;

procedure TFExecSQL.AFastQuerysExecute(Sender: TObject);
begin
 AFastQuerys.checked:=Not AFastquerys.checked;
 ABidirectional.Enabled:=Not AFastQuerys.checked;
end;

procedure TFExecSQL.AClearBufferExecute(Sender: TObject);
var
 i:integer;
begin
 //
 for i:=0 to sentences.count-1 do
 begin
  TStringlist(sentences.items[i]).free;
 end;
 sentences.Clear;
 sentenceindex:=0;
 APrior.enabled:=false;
 ANext.enabled:=false;
end;

procedure TFExecSQL.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
 res:TModalresult;
begin
 try
  if ACommit.enabled then
  begin
   res:=Messagedlg(SRpTransActive,mtWarning,[mbYes,mbNo,mbcancel],0);
   if res=mrYes then
    ACommit.Execute
   else
    if res=mrNo then
     ARollback.Execute
    else
     canclose:=false;
  end;
 except
  // Error in database connections
  on E:Exception do
  begin
   Messagedlg(E.Message,mtError,[mbok],0);
   canclose:=true;
  end;
 end;
end;

procedure TFExecSQL.ACommitddlExecute(Sender: TObject);
begin
 ACommitddl.checked:=Not ACommitddl.checked;
end;

procedure TFExecSQL.ACommitretExecute(Sender: TObject);
begin
 Trans.commitretaining;
 ARollback.enabled:=True;
 ACommitret.enabled:=True;
 ACommit.enabled:=True;
 ANewtrans.enabled:=False;
 ATranops.enabled:=False;
end;

procedure TFExecSQL.AParamsExecute(Sender: TObject);
begin
 if AFastquerys.checked then
 begin
  if ANewtrans.Enabled then
   ANewtrans.Execute;
  if IBSQL1.sql.text<>MEdit.text then
   IBSQL1.sql.text:=MEdit.text;
  IBSQL1.Prepare;
  ChangeParamValues(IBSQL1);
 end
 else
 begin
  IBQuery1.sql.text:=MEdit.text;
  ChangeParamValues(IBQuery1);
 end;
end;

procedure TFExecSQL.DoBlobColumns;
var
 i:integer;
begin
 for i:=0 to dbgrid1.columns.count-1 do
 begin
  if (dbgrid1.Columns.Items[i].Field is TBlobField) then
  begin
   dbgrid1.Columns.Items[i].ButtonStyle:=cbsellipsis
  end;
 end;
end;

procedure TFExecSQL.DBGrid1EditButtonClick(Sender: TObject);
begin
 if dbgrid1.SelectedField=nil then
  exit;
 if (dbgrid1.SelectedField is TBlobField) then
 begin
  if dbgrid1.SelectedField.datatype=ftMemo then
   ShowBlobForm(dbgrid1.SelectedField,0)
  else
   ShowBlobForm(dbgrid1.SelectedField,1);
 end;
end;


 procedure TFExecSQL.AparamcheckExecute(Sender: TObject);
begin
 AParamCheck.checked:=Not AParamcheck.checked;
end;


end.
