{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       New constraint wizard                           }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit ibnewconstraint;

interface

uses Classes, QForms, QControls, QStdCtrls,
  IBDatabase, IBSQL,ibacutils,ibacconst,SysUtils,
  QDialogs, QButtons, QExtCtrls, QComCtrls;

type
  TFNewconstraint = class(TForm)
    IBSQL1: TIBSQL;
    Trans: TIBTransaction;
    Panel1: TPanel;
    Label1: TLabel;
    LTablename: TLabel;
    Label2: TLabel;
    EConstraintname: TEdit;
    Panel2: TPanel;
    OKBtn: TButton;
    CancelBtn: TButton;
    PControl: TPageControl;
    TabType: TTabSheet;
    RadioType: TRadioGroup;
    Tabselect: TTabSheet;
    LAval: TListBox;
    Label3: TLabel;
    BADD: TBitBtn;
    BRemove: TBitBtn;
    Bup: TBitBtn;
    BDown: TBitBtn;
    LSelected: TListBox;
    Label4: TLabel;
    TabReferences: TTabSheet;
    Label5: TLabel;
    ComboTables: TComboBox;
    LRfields: TListBox;
    Label6: TLabel;
    TabCheck: TTabSheet;
    LAval2: TListBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    ComboUpdate: TComboBox;
    ComboDelete: TComboBox;
    BNext: TButton;
    BBack: TButton;
    CheckUpdate: TCheckBox;
    MEdit: TMemo;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PControlChange(Sender: TObject);
    procedure ComboTablesClick(Sender: TObject);
    procedure BDownClick(Sender: TObject);
    procedure BupClick(Sender: TObject);
    procedure BRemoveClick(Sender: TObject);
    procedure BADDClick(Sender: TObject);
    procedure LAval2DblClick(Sender: TObject);
    procedure BBackClick(Sender: TObject);
    procedure BNextClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    { Private declarations }
    fieldlist:TStringlist;
    docreate:boolean;
    tablename:string;
    created:boolean;
    procedure fillavalfields(dia:TFFetching);
    procedure DoCreateconstraint;
    procedure Fillcombotables(dia:TFFetching);
    procedure FillRFields(dia:TFFetching);
    procedure Docreatecheck;
    procedure Docreateprimary;
    procedure DoCreateforeign;
    procedure DoCreateUnique;
  public
    { Public declarations }
    base:TIBDatabase;
  end;

function ibcreateconstraint(base:TIBDatabase;table:string):boolean;

implementation

{$R *.xfm}

function ibcreateconstraint(base:TIBDatabase;table:string):boolean;
var
 dia:TFNewconstraint;
begin
 dia:=TFNewconstraint.create(Application);
 try
  dia.trans.defaultdatabase:=base;
  dia.ibsql1.database:=base;
  dia.tablename:=table;
  dia.base:=base;
  dia.ShowModal;
  result:=dia.docreate;
 finally
  dia.free;
 end;
end;

procedure TFNewconstraint.FormShow(Sender: TObject);
begin
 LTablename.caption:=tablename;
 EConstraintName.text:='';
 ExecuteActionProgres(fillavalfields,true,nil);
 PControl.activepage:=TabType;
 RadioType.Itemindex:=0;
 ComboUpdate.itemindex:=0;
 ComboDelete.itemindex:=0;
end;

procedure TFNewconstraint.fillavalfields(dia:TFFetching);
begin
 Trans.starttransaction;
 try
  IBSQL1.sql.text:='SELECT RDB$FIELD_NAME FROM RDB$RELATION_FIELDS '+
   ' WHERE RDB$RELATION_NAME='''+tablename+''' ORDER BY RDB$FIELD_POSITION';
  IBSQL1.ExecQuery;
  try
   While Not IBSQL1.EOF do
   begin
    Fieldlist.add(IBSQL1.FieldByName('RDB$FIELD_NAME').AsString);
    IBSQL1.Next;
    dia.IncFetch(1);
   end;
  finally
   IBSQL1.CLose;
  end;
 finally
  trans.rollback;
 end;
 LAval.items.assign(Fieldlist);
 LAval2.items.assign(Fieldlist);
 if fieldlist.count>0 then
 begin
  LAval.itemindex:=0;
  LAval2.itemindex:=0;
 end;
end;

procedure TFNewconstraint.FormCreate(Sender: TObject);
begin
 fieldlist:=TStringlist.create;

// SendMessage(LAval.Handle,LB_SETHORIZONTALEXTENT,512,0);
// SendMessage(LSelected.Handle,LB_SETHORIZONTALEXTENT,512,0);
// SendMessage(LRFields.Handle,LB_SETHORIZONTALEXTENT,512,0);

 TabCheck.tabvisible:=false;
 TabReferences.tabvisible:=false;
 TabSelect.tabvisible:=false;
 MEdit.text:='CHECK (  ';
// MEdit.PositionFromPoint(7,1);
 created:=true;
end;

procedure TFNewconstraint.FormDestroy(Sender: TObject);
begin
 fieldlist.free;
end;


procedure TFNewconstraint.BADDClick(Sender: TObject);
begin
 if LAval.items.count<1 then
  exit;
 if lAval.itemindex<0 then
  exit;
 LSelected.Items.Add(laval.items.strings[laval.itemindex]);
 LAval.items.delete(laval.itemindex);
 if LSelected.items.count=1 then
  LSelected.itemindex:=0;
 if LAval.items.count>0 then
  LAval.itemindex:=0;
end;

procedure TFNewconstraint.BRemoveClick(Sender: TObject);
var
 oldaval:string;
 alist:TStringlist;
 i,index:integer;
begin
 if LSelected.items.count<1 then
  exit;
 if lSelected.itemindex<0 then
  exit;
 index:=lselected.itemindex;
 LSelected.items.delete(lselected.itemindex);
 if LSelected.items.count>0 then
  LSelected.itemindex:=index;
 // Restores all the fields to position the field
 alist:=TStringlist.create;
 try
  oldaval:='';
  if LAval.itemindex>=0 then
   oldaval:=LAval.items.strings[laval.itemindex];
  alist.assign(fieldlist);
  for i:=0 to LSelected.items.count-1 do
  begin
   index:=alist.indexof(LSelected.items.strings[i]);
   if index>=0 then
    alist.delete(index);
  end;
  LAval.items.assign(alist);
  index:=laval.items.indexof(oldaval);
  if index>=0 then
   Laval.itemindex:=index;
 finally
  alist.free;
 end;
end;

procedure TFNewconstraint.BupClick(Sender: TObject);
var
 afield:string;
begin
 if LSelected.items.count<1 then
  exit;
 if lSelected.itemindex<1 then
  exit;
 with lselected do
 begin
  afield:=Items.strings[itemindex-1];
  items.strings[itemindex-1]:=items.strings[itemindex];
  items.strings[itemindex]:=afield;
  itemindex:=itemindex-1;
 end;
end;

procedure TFNewconstraint.BDownClick(Sender: TObject);
var
 afield:string;
begin
 if LSelected.items.count<1 then
  exit;
 if lSelected.itemindex<0 then
  exit;
 if lSelected.itemindex>=lselected.items.count-1 then
  exit;
 with lselected do
 begin
  afield:=Items.strings[itemindex+1];
  items.strings[itemindex+1]:=items.strings[itemindex];
  items.strings[itemindex]:=afield;
  itemindex:=itemindex+1;
 end;
end;

procedure TFNewconstraint.Fillcombotables(dia:TFFetching);
begin
 combotables.items.clear;
 trans.starttransaction;
 try
  IBSQL1.sql.text:='SELECT RDB$RELATION_NAME FROM RDB$RELATIONS '+
    ' WHERE (RDB$VIEW_SOURCE IS NULL) '+
    ' AND (NOT (RDB$RELATION_NAME LIKE ''RDB$%'')) '+
    ' ORDER BY RDB$RELATION_NAME';
  IBSQL1.Execquery;
  try
   While Not IBSQL1.EOF do
   begin
    ComboTables.items.add(IBSQL1.Fieldbyname('RDB$RELATION_NAME').AsString);
    IBSQL1.Next;
    dia.incfetch(1);
   end;
  finally
   IBSQL1.close;
  end;
 finally
  trans.rollback;
 end;
end;

procedure TFNewconstraint.PControlChange(Sender: TObject);
begin
 //
 if not created then
  exit;
 if PControl.ActivePage=TabReferences then
 begin
  ComboTables.itemindex:=-1;
  Executeactionprogres(Fillcombotables,true,nil);
  BBack.Visible:=True;
  BNext.Visible:=False;
  OKBtn.visible:=true;
  TabCheck.Tabvisible:=false;
  TabSelect.Tabvisible:=false;
  Tabtype.TabVisible:=false;
  TabReferences.TabVisible:=True;
  exit;
 end;
 if PControl.ActivePage=TabType then
 begin
  BBack.Visible:=False;
  BNext.Visible:=True;
  OKBtn.visible:=False;
  TabCheck.Tabvisible:=false;
  TabSelect.Tabvisible:=false;
  Tabtype.TabVisible:=True;
  TabReferences.TabVisible:=False;
  exit;
 end;
 if PControl.ActivePage=TabCheck then
 begin
  BBack.Visible:=TRue;
  BNext.Visible:=False;
  OKBtn.visible:=True;
  TabCheck.Tabvisible:=true;
  TabSelect.Tabvisible:=false;
  Tabtype.TabVisible:=false;
  TabReferences.TabVisible:=False;
  Activecontrol:=MEdit;
  exit;
 end;
 if PControl.ActivePage=TabSelect then
 begin
  case RadioType.ItemIndex of
   1:
    begin
     BBack.Visible:=TRue;
     BNext.Visible:=False;
     OKBtn.visible:=True;
     TabCheck.Tabvisible:=False;
     TabSelect.Tabvisible:=True;
     Tabtype.TabVisible:=false;
     TabReferences.TabVisible:=False;
    end;
   2:
    begin
     BBack.Visible:=True;
     BNext.Visible:=True;
     OKBtn.visible:=False;
     TabCheck.Tabvisible:=false;
     TabSelect.Tabvisible:=True;
     Tabtype.TabVisible:=false;
     TabReferences.TabVisible:=False;
    end;
   3:
    begin
     BBack.Visible:=True;
     BNext.Visible:=False;
     OKBtn.visible:=True;
     TabCheck.Tabvisible:=false;
     TabSelect.Tabvisible:=True;
     Tabtype.TabVisible:=false;
     TabReferences.TabVisible:=False;
    end;
   else
    begin
     BBack.Visible:=True;
     BNext.Visible:=False;
     OKBtn.visible:=False;
     TabCheck.Tabvisible:=false;
     TabSelect.Tabvisible:=True;
     Tabtype.TabVisible:=false;
     TabReferences.TabVisible:=False;
    end;
  end;
  exit;
 end;
end;

procedure TFNewconstraint.ComboTablesClick(Sender: TObject);
begin
 // Fills the LRFields list
 Executeactionprogres(FillRFields,true,nil);
end;

procedure TFNewconstraint.FillRFields(dia:TFFetching);
var
 afields:string;
 aindexname:string;
 adeli:string;
begin
 LRFields.items.clear;
 if Length(ComboTables.text)<1 then
  exit;
 adeli:='';
 if base.sqldialect=3 then
  adeli:='"';
 trans.starttransaction;
 try
  IBSQL1.sql.text:='SELECT I.RDB$INDEX_NAME,I.RDB$FIELD_NAME '+
    ' FROM RDB$RELATION_CONSTRAINTS C'+
    ' LEFT OUTER JOIN RDB$INDEX_SEGMENTS I '+
    ' ON C.RDB$INDEX_NAME=I.RDB$INDEX_NAME '+
    ' WHERE C.RDB$RELATION_NAME='''+ComboTables.text+
    ''' AND ((C.RDB$CONSTRAINT_TYPE LIKE ''PRIMARY KEY%'') '+
    ' OR (C.RDB$CONSTRAINT_TYPE LIKE ''UNIQUE%'')) '+
    ' ORDER BY I.RDB$INDEX_NAME,I.RDB$FIELD_POSITION';
  IBSQL1.Execquery;
  try
   afields:='';
   aindexname:='';
   While Not IBSQL1.EOF do
   begin
    if aindexname<>Trim(IBSQL1.FieldByName('RDB$INDEX_NAME').Asstring) then
    begin
     if aindexname<>'' then
      LRFields.Items.add(afields);
     aindexname:=Trim(IBSQL1.FieldByName('RDB$INDEX_NAME').Asstring);
     afields:=adeli+Trim(IBSQL1.FieldByName('RDB$FIELD_NAME').Asstring+adeli)
    end
    else
    begin
     afields:=afields+','+adeli+Trim(IBSQL1.FieldByName('RDB$FIELD_NAME').Asstring)+adeli;
    end;
    IBSQL1.Next;
    dia.incfetch(1);
   end;
   if aindexname<>'' then
    LRFields.Items.add(afields);
  finally
   IBSQL1.close;
  end;
 finally
  trans.rollback;
 end;
 if LRFields.items.count>0 then
  LRFields.itemindex:=0;
end;

procedure TFNewconstraint.LAval2DblClick(Sender: TObject);
begin
 if LAval2.itemindex>=0 then
  MEdit.text:=MEdit.text+LAval2.items.Strings[LAval2.itemindex];
end;

procedure TFNewconstraint.BBackClick(Sender: TObject);
begin
 if PControl.Activepage=Tabreferences then
 begin
  TabSelect.TabVisible:=true;
  PControl.ActivePage:=TabSelect;
  PControlChange(PControl);
  exit;
 end;
 if PControl.Activepage=TabSelect then
 begin
  TabType.TabVisible:=true;
  PControl.ActivePage:=TabType;
  PControlChange(PControl);
  exit;
 end;
 if PControl.Activepage=TabCheck then
 begin
  TabType.TabVisible:=true;
  PControl.ActivePage:=TabType;
  PControlChange(PControl);
  exit;
 end;
end;

procedure TFNewconstraint.BNextClick(Sender: TObject);
begin
 if PControl.Activepage=TabType then
 begin
  case RadioType.itemindex of
   0:
    begin
     TabCheck.TabVisible:=true;
     PControl.ActivePage:=TabCheck;
     PControlChange(PControl);
    end;
   1:
    begin
     TabSelect.TabVisible:=true;
     PControl.ActivePage:=TabSelect;
     PControlChange(PControl);
    end;
   2:
    begin
     TabSelect.TabVisible:=true;
     PControl.ActivePage:=TabSelect;
     PControlChange(PControl);
    end;
   else
    begin
     TabSelect.TabVisible:=true;
     PControl.ActivePage:=TabSelect;
     PControlChange(PControl);
    end;
  end;
  exit;
 end;
 if PControl.Activepage=TabSelect then
 begin
  case RadioType.itemindex of
   2:
    begin
     if LSelected.items.count<1 then
      Raise Exception.create(SRpNoFieldsSelected);
     TabReferences.TabVisible:=true;
     PControl.ActivePage:=TabReferences;
     PControlChange(PControl);
    end;
   else
    begin
     TabType.TabVisible:=true;
     PControl.ActivePage:=TabType;
     PControlChange(PControl);
    end;
  end;
  exit;
 end;
 if PControl.Activepage=TabCheck then
 begin
  TabType.TabVisible:=true;
  PControl.ActivePage:=TabType;
  PControlChange(PControl);
  exit;
 end;
end;

procedure TFNewconstraint.OKBtnClick(Sender: TObject);
begin
 DoCreateConstraint;
 docreate:=true;
 Close;
end;

procedure TFNewconstraint.DoCreateConstraint;
begin
 case RadioType.itemindex of
  0:
   Docreatecheck;
  1:
   Docreateprimary;
  2:
   DoCreateforeign;
  else
   DoCreateUnique;
 end;
end;

procedure TFNewconstraint.Docreatecheck;
var
 index:integer;
 adeli:string;
begin
 adeli:='';
 if base.sqldialect=3 then
  adeli:='"';
 trans.starttransaction;
 try
  IBSQL1.SQL.text:='ALTER TABLE '+tablename+
   ' ADD ';
  if length(trim(EConstraintname.text))>0 then
   IBSQL1.SQL.text:=IBSQL1.SQL.text+' CONSTRAINT '+adeli+
    EConstraintname.text+adeli+' ';
  IBSQL1.SQL.text:=IBSQL1.SQL.text+MEdit.text;
  IBSQL1.Execquery;
  if CheckUpdate.checked then
  begin
   trans.commit;
   trans.starttransaction;
   try
    if laval2.itemindex>=0 then
     index:=laval2.itemindex
    else
     index:=0;
    IBSQL1.SQL.text:='UPDATE '+adeli+tablename+adeli+
     ' SET '+adeli+fieldlist.strings[index]+adeli+'='+fieldlist.strings[index];
    IBSQL1.Execquery;
   except
    On E:Exception do
    begin
     MessageDlg(SRpBadConstraintCreated,mtWarning,[mbOK],0);
    end;
   end;
  end;
  trans.commit;
 except
  trans.rollback;
  raise;
 end;
end;

procedure TFNewconstraint.Docreateprimary;
var
 i:integer;
 adeli:string;
begin
 if LSelected.items.count<1 then
  Raise Exception.create(SRpNoFieldsSelected);
 adeli:='';
 if base.sqldialect=3 then
  adeli:='"';
 trans.starttransaction;
 try
  IBSQL1.SQL.text:='ALTER TABLE '+adeli+tablename+adeli+
   ' ADD ';
  if length(trim(EConstraintname.text))>0 then
   IBSQL1.SQL.text:=IBSQL1.SQL.text+' CONSTRAINT '+adeli+
    EConstraintname.text+adeli+' ';
  IBSQL1.SQL.text:=IBSQL1.SQL.text+ ' PRIMARY KEY (';
  IBSQL1.SQL.text:=IBSQL1.SQL.text+adeli+LSelected.items.strings[0]+adeli;
  for i:=1 To LSelected.items.count-1 do
  begin
   IBSQL1.SQL.text:=IBSQL1.SQL.text+','+adeli+LSelected.items.strings[i]+adeli;
  end;
  IBSQL1.SQL.text:=IBSQL1.SQL.text+')';
  IBSQL1.Execquery;
  trans.commit;
 except
  trans.rollback;
  raise;
 end;
end;

procedure TFNewconstraint.DoCreateforeign;
var
 i:integer;
 adeli:string;
begin
 if Length(Trim(Combotables.text))<1 then
  Raise Exception.create(SRpNoTableSelected);
 if LSelected.items.count<1 then
  Raise Exception.create(SRpNoFieldsSelected);
 if LRFields.items.count<1 then
  Raise Exception.create(SRpNoFieldsSelected);
 if LRFields.itemindex<0 then
  Raise Exception.create(SRpNoFieldsSelected);
 adeli:='';
 if base.sqldialect=3 then
  adeli:='"';
 trans.starttransaction;
 try
  IBSQL1.SQL.text:='ALTER TABLE '+adeli+tablename+adeli+
   ' ADD ';
  if length(trim(EConstraintname.text))>0 then
   IBSQL1.SQL.text:=IBSQL1.SQL.text+' CONSTRAINT '+adeli+
    EConstraintname.text+adeli;
  IBSQL1.SQL.text:=IBSQL1.SQL.text+ ' FOREIGN KEY (';
  IBSQL1.SQL.text:=IBSQL1.SQL.text+adeli+LSelected.items.strings[0]+adeli;
  for i:=1 To LSelected.items.count-1 do
  begin
   IBSQL1.SQL.text:=IBSQL1.SQL.text+','+LSelected.items.strings[i];
  end;
  IBSQL1.SQL.text:=IBSQL1.SQL.text+') REFERENCES '+adeli+
   combotables.text+adeli+' ('+
   LRFields.items.strings[LRFields.itemindex]+')';
  IBSQL1.SQL.text:=IBSQL1.SQL.text+' ON UPDATE '+ComboUpdate.TExt;
  IBSQL1.SQL.text:=IBSQL1.SQL.text+' ON DELETE '+ComboDelete.TExt;
  IBSQL1.Execquery;
  trans.commit;
 except
  trans.rollback;
  raise;
 end;
end;

procedure TFNewconstraint.DoCreateUnique;
var
 i:integer;
 adeli:string;
begin
 if LSelected.items.count<1 then
  Raise Exception.create(SRpNoFieldsSelected);
 adeli:='';
 if base.sqldialect=3 then
  adeli:='"';
 trans.starttransaction;
 try
  IBSQL1.SQL.text:='ALTER TABLE '+adeli+tablename+adeli+
   ' ADD ';
  if length(trim(EConstraintname.text))>0 then
   IBSQL1.SQL.text:=IBSQL1.SQL.text+' CONSTRAINT '+adeli+
    EConstraintname.text+adeli+' ';
  IBSQL1.SQL.text:=IBSQL1.SQL.text+ ' UNIQUE (';
  IBSQL1.SQL.text:=IBSQL1.SQL.text+adeli+LSelected.items.strings[0]+adeli;
  for i:=1 To LSelected.items.count-1 do
  begin
   IBSQL1.SQL.text:=IBSQL1.SQL.text+','+adeli+LSelected.items.strings[i]+adeli;
  end;
  IBSQL1.SQL.text:=IBSQL1.SQL.text+')';
  IBSQL1.Execquery;
  trans.commit;
 except
  trans.rollback;
  raise;
 end;
end;

end.
