{*******************************************************}
{                                                       }
{       rpversion                                       }
{       A unit to test if we are on NT or 9x plattform  }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit rpversion;


interface

uses sysutils;

resourcestring
 SRPError='Error';

{$IFDEF MSWINDOWS}
var
 osinfo:TOsVersionInfo;
{$ENDIF}

function IsWindowsNT:Boolean;

implementation

var
 obtainedversion:Boolean;

function IsWindowsNT:Boolean;
begin
 Result:=false;
 {$IFDEF MSWINDOWS}
 if Not obtainedversion then
 begin
  osinfo.dwOSVersionInfoSize:=sizeof(osinfo);
  if Not GetVersionEx(osinfo) then
   Raise Exception.Create(SrpError+' GetVersionEx');
   obtainedversion:=True;
 end;
 Result:=osinfo.dwPlatformId=VER_PLATFORM_WIN32_NT;
 {$ENDIF}
end;

initialization

obtainedversion:=false;

end.
