unit rpviewblob;

interface

uses Classes, QForms,SysUtils,
  Db, QComCtrls, QStdCtrls, QExtCtrls, QControls,
  QDBCtrls;

type
  TFViewBlob = class(TForm)
    Panel2: TPanel;
    Label1: TLabel;
    Combotype: TComboBox;
    PZoom: TPanel;
    TZoom: TTrackBar;
    Label2: TLabel;
    ScrollBox1: TScrollBox;
    dbIma: TDBImage;
    DataSource1: TDataSource;
    EMemo: TDBMemo;
    Label3: TLabel;
    LSize: TLabel;
    procedure CombotypeClick(Sender: TObject);
    procedure TZoomChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure ShowBlobForm(field:TField;deftype:integer);

implementation

{$R *.xfm}

procedure ShowBlobForm(field:TField;deftype:integer);
var
 dia:TFViewBlob;
 streamsize:Largeint;
 stream:TStream;
begin
 dia:=TFViewBlob.create(application);
 try
  dia.DataSource1.dataset:=field.dataset;
  dia.dbIma.DataField:=field.FieldName;
  dia.EMemo.datafield:=field.fieldname;
  dia.Combotype.itemindex:=0;
  if deftype=1 then
   dia.Combotype.itemindex:=deftype;
  dia.Combotypeclick(dia);
  if field.IsNull then
   dia.LSize.caption:='Null'
  else
  begin
   stream:=field.dataset.CreateBlobStream(field,bmread);
   try
    streamsize:=Stream.size;
    if streamsize<1024 then
     dia.LSize.caption:=Formatfloat('#,###0',streamsize)+' bytes'
    else
     if streamsize>(1024*1024) then
      dia.LSize.caption:=Formatfloat('#,###0.##',streamsize/(1024*1024))+' Mbytes'
     else
      dia.LSize.caption:=Formatfloat('#,###0.##',streamsize/1024)+' Kbytes';
   finally
    stream.free;
   end;
  end;
  dia.showmodal;
 finally
  dia.free;
 end;
end;


procedure TFViewBlob.CombotypeClick(Sender: TObject);
begin
 Case Combotype.itemindex of
  0:
   begin
    PZoom.visible:=false;
    ScrollBox1.visible:=false;
    dbima.datasource:=nil;
    EMemo.visible:=true;
    EMemo.datasource:=datasource1;
   end;
  1:
   begin
    PZoom.visible:=True;
    EMemo.visible:=false;
    EMemo.datasource:=nil;
    dbima.datasource:=datasource1;
    ScrollBox1.visible:=True;
   end;
 end;
end;

procedure TFViewBlob.TZoomChange(Sender: TObject);
begin
// dbima.zoom:=TZoom.Position*10;
end;

end.
