{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       Main form                                       }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit mainform;

interface

uses
  SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  inifiles,rpshfolder,
  ibexecsql,tablenew,databaseform,
  Rpibdb, ibdatabase,opendatabase,rpstdutils, ibacconst,
  QImgList, QActnList, QMenus, QTypes, QComCtrls,QExtCtrls, DB, DBClient,
  QGrids, QDBGrids,ibman;

type
  TFMain = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    ActionList1: TActionList;
    ANew: TAction;
    AOpen: TAction;
    New1: TMenuItem;
    StatusBar: TStatusBar;
    ToolBar: TToolBar;
    BNew: TToolButton;
    BOpen: TToolButton;
    ToolButton1: TToolButton;
    AExit: TAction;
    AViewStatusbar: TAction;
    AViewToolbar: TAction;
    View1: TMenuItem;
    MStatusbar: TMenuItem;
    Mtoolbar: TMenuItem;
    ADefuser: TAction;
    Options1: TMenuItem;
    Defaultuser1: TMenuItem;
    ADropdatabase: TAction;
    Delte1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    ASystemdata: TAction;
    AUserdatabases: TAction;
    Userdatabases1: TMenuItem;
    Systemdatabases1: TMenuItem;
    ADatabaseconf: TAction;
    Configuradatabases1: TMenuItem;
    dbconf: TRpDBIBConf;
    AHelpContents: TAction;
    Help1: TMenuItem;
    Contents1: TMenuItem;
    Index1: TMenuItem;
    Search1: TMenuItem;
    AHelpIndex: TAction;
    AHelpSearch: TAction;
    N3: TMenuItem;
    About1: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    ABackup: TAction;
    ARestore: TAction;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    Backup1: TMenuItem;
    ARestore1: TMenuItem;
    ToolButton4: TToolButton;
    Tools1: TMenuItem;
    ARepair: TAction;
    AStatistics: TAction;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    Repairdatabase1: TMenuItem;
    Databasestatistics1: TMenuItem;
    ASerprops: TAction;
    ADbprops: TAction;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    Databaseproperties1: TMenuItem;
    N6: TMenuItem;
    Serverproperties1: TMenuItem;
    AUsers: TAction;
    ToolButton11: TToolButton;
    Users1: TMenuItem;
    IconImages: TImageList;
    DWindows: TClientDataSet;
    SWindows: TDataSource;
    DWindowsObject: TStringField;
    DWindowsObjecttype: TStringField;
    DWindowsDatabase: TStringField;
    PActiveW: TPanel;
    Panel2: TPanel;
    Gridindows: TDBGrid;
    procedure FormCreate(Sender: TObject);
    procedure ANewExecute(Sender: TObject);
    procedure AOpenExecute(Sender: TObject);
    procedure AViewStatusbarExecute(Sender: TObject);
    procedure AViewToolbarExecute(Sender: TObject);
    procedure ADefuserExecute(Sender: TObject);
    procedure ASystemdataExecute(Sender: TObject);
    procedure AUserdatabasesExecute(Sender: TObject);
    procedure ADatabaseconfExecute(Sender: TObject);
    procedure AExitExecute(Sender: TObject);
    procedure ADropdatabaseExecute(Sender: TObject);
    procedure AHelpContentsExecute(Sender: TObject);
    procedure AHelpIndexExecute(Sender: TObject);
    procedure AHelpSearchExecute(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure TileHorizontal1Click(Sender: TObject);
    procedure TileVertical1Click(Sender: TObject);
    procedure Arrange1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure ARestoreExecute(Sender: TObject);
    procedure ABackupExecute(Sender: TObject);
    procedure ARepairExecute(Sender: TObject);
    procedure AStatisticsExecute(Sender: TObject);
    procedure ASerpropsExecute(Sender: TObject);
    procedure ADbpropsExecute(Sender: TObject);
    procedure AUsersExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure GridindowsDblClick(Sender: TObject);
    procedure DWindowsAfterDelete(DataSet: TDataSet);
    procedure DWindowsAfterPost(DataSet: TDataSet);
  private
    { Private declarations }
    procedure OnHint(Sender:TObject);
    procedure Savesystemconfig;
    procedure Downgradedialect(Sender:TObject);
  protected
  public
    { Public declarations }
    username,password,charset,role:string;
    server,filename:string;
    protocol:TRpIBXProtocol;
    rememberpassword,systemconfig:boolean;
    dialect:integer;
    dblist:TStringlist;
    execsqlprefs:TExecsqlprefs;
    databaseprefs:TDatabaseprefs;
    edittableprefs:TEditTableprefs;
  end;

var
  FMain: TFMain;

implementation

uses ibacutils, usernameform, newdatabase, delbase, aboutform,
  ibresto, backupdatabase, repairdatabase, databasestat, serverprops,
  modibase, userman;

{$R *.xfm}

procedure TFMain.FormCreate(Sender: TObject);
var
 inifile:TInifile;
 afield:TField;
begin
 afield:=TIntegerField.Create(DWindows);
 afield.visible:=false;
 afield.FieldName:='Window';
 afield.name:='DWindowsWindow';
 afield.DataSet:=DWindows;
 DWindows.CreateDataSet;

 dblist:=TStringlist.create;
 dblist.sorted:=true;
 dialect:=1;
 Application.OnHint:=OnHint;
 // Reads the user configuration
 inifile:=TInifile.Create(Obtainininameuserconfig('','ibaccess','config'));
 try
  ibman.globalserverpath:=inifile.ReadString('Userconfig','ServerPath','');
  username:=inifile.ReadString('Userconfig','Username','');
  password:=inifile.ReadString('Userconfig','Password','');
  rememberpassword:=inifile.ReadBool('Userconfig','RememberPassword',True);
  Systemconfig:=inifile.ReadBool('Userconfig','SystemConfig',False);
  charset:=inifile.ReadString('Userconfig','Charset','WIN1252');
  role:=inifile.ReadString('Userconfig','Role','');
  inifile.ReadString('Userconfig','Charset','WIN1252');

  // FExecSQL preferences
  execsqlprefs:=[];
  if inifile.ReadBool('ExecSQLprefs','FastQuerys',True) then
   include(execsqlprefs,fspfastq);
  if inifile.ReadBool('ExecSQLprefs','ParamCheck',True) then
   include(execsqlprefs,fspparamcheck);
  if inifile.ReadBool('ExecSQLprefs','BidiQuerys',True) then
   include(execsqlprefs,fspbidiq);
  if inifile.ReadBool('ExecSQLprefs','ShowStat',false) then
   include(execsqlprefs,fspshowstat);
  if inifile.ReadBool('ExecSQLprefs','ShowQPlan',True) then
   include(execsqlprefs,fspqplan);
  if inifile.ReadBool('ExecSQLprefs','SaveHistory',True) then
   include(execsqlprefs,fspsaveh);
  if inifile.ReadBool('ExecSQLprefs','CommitDLL',True) then
   include(execsqlprefs,fspcommitddl);

  // FNewtable prefs
  edittableprefs:=[];
  if inifile.ReadBool('EditTableprefs','Autocommit',false) then
   include(edittableprefs,fetautocommit);
  if inifile.ReadBool('EditTableprefs','Gridedition',True) then
   include(edittableprefs,fetgridedit);
  if inifile.ReadBool('EditTableprefs','ResyncRecord',False) then
   include(edittableprefs,fetresync);
  if inifile.ReadBool('EditTableprefs','Readonly',False) then
   include(edittableprefs,fetopenreadonly);

  // FDatabase prefs
  databaseprefs:=[];
  if inifile.ReadBool('Databaseprefs','Autorefresh',true) then
   include(databaseprefs,fedautorefresh);
  if inifile.ReadBool('Databaseprefs','Systemdomains',true) then
   include(databaseprefs,fedsystemdomains);
  if inifile.ReadBool('Databaseprefs','Details',false) then
   include(databaseprefs,feddetails);
  if inifile.ReadBool('Databaseprefs','Systemdata',false) then
   include(databaseprefs,fedsystemdata);

  ibman.globalusecommandline:=inifile.ReadBool('User config','Commandline',false);

 finally
  inifile.free;
 end;
 dbconf.Systemconfig:=Systemconfig;
 ASystemdata.Checked:=Systemconfig;
 Auserdatabases.Checked:=Not Systemconfig;
 dbconf.LoadAliases;
end;

procedure TFMain.OnHint(Sender:TObject);
begin
 if Length(Application.Hint) > 0 then
 begin
   StatusBar.SimplePanel := True;
   StatusBar.SimpleText := Application.Hint;
 end
  else StatusBar.SimplePanel := False;
end;

procedure TFMain.ANewExecute(Sender: TObject);
var
 dbase:TIBDatabase;
begin
 // Creates a new database
 dbase:=TIBDatabase.Create(Application);
 try
  Generatenewname(dbase);
  dbase.LoginPrompt:=false;
  if CreateNewdatabase(dbase,server,filename,username,password,charset,role,protocol,dbconf) then
  begin
   // Also opens de database
   dbase.connected:=True;
   dbase.OnDialectDowngradeWarning:=Downgradedialect;
   Application.CreateForm(TFDatabase, FDatabase);
   DWindows.AppendRecord(
    [server,
    SRpDatabase,BuildIBDatabaseName((Length(server)>0),protocol,server,filename),integer(FDatabase)]);

   FDatabase.caption:=FDatabase.caption+' - '+dbase.databasename;
   FDatabase.server:=server;
   FDatabase.filename:=filename;
   FDatabase.username:=username;
   FDatabase.password:=password;
   FDatabase.protocol:=protocol;
   FDatabase.role:=role;
   Application.RemoveComponent(dbase);
   Application.InsertComponent(dbase);
   FDatabase.dbase:=dbase;
   // Bug on IBX
   dbase.InternalTransaction.DefaultDatabase:=dbase;
   // Insert into mainform database list
   FMain.dblist.AddObject(dbase.DatabaseName,dbase);
  end
  else
  begin
   dbase.free;
  end;
 except
  dbase.free;
  raise;
 end;
end;

procedure TFMain.AOpenExecute(Sender: TObject);
var
 dbase:TIBDatabase;
begin
 server:='';
 filename:='';
 // Opens an existing database
 dbase:=TIBDatabase.Create(Application);
 try
  Generatenewname(dbase);
  dbase.LoginPrompt:=false;
  dbase.OnDialectDowngradeWarning:=Downgradedialect;
  if OpenIbDatabase(dbase,server,filename,username,password,role,charset,protocol,dialect,dbconf) then
  begin
   Application.CreateForm(TFDatabase, FDatabase);
   DWindows.AppendRecord(
    [server,
    SRpDatabase,BuildIBDatabaseName((Length(server)>0),protocol,server,filename),integer(FDatabase)]);
   FDatabase.caption:=FDatabase.caption+' - '+dbase.databasename;
   FDatabase.server:=server;
   FDatabase.filename:=filename;
   FDatabase.username:=username;
   FDatabase.password:=password;
   FDatabase.role:=role;
   FDatabase.protocol:=protocol;
   FDatabase.charset:=charset;
   Application.RemoveComponent(dbase);
   Application.InsertComponent(dbase);
   FDatabase.dbase:=dbase;
   // Bug on IBX
   dbase.InternalTransaction.DefaultDatabase:=dbase;
   // Insert into mainform database list
   FMain.dblist.AddObject(dbase.DatabaseName,dbase);
  end
  else
  begin
   dbase.free;
  end;
 except
  dbase.free;
  raise;
 end;
end;

procedure TFMain.AViewStatusbarExecute(Sender: TObject);
begin
 AViewStatusbar.Checked:=Not AViewStatusbar.checked;
 Statusbar.visible:=AViewStatusbar.checked;
end;

procedure TFMain.AViewToolbarExecute(Sender: TObject);
begin
 AViewToolbar.Checked:=Not AViewToolbar.checked;
 Toolbar.visible:=AViewToolbar.checked;
end;

procedure TFMain.ADefuserExecute(Sender: TObject);
begin
 // Shows the default user form
 CreateFormandshow(TFUsername);
end;


procedure TFMain.Savesystemconfig;
var
 inifile:TInifile;
begin
 // Sets the confyg mode and reads the configuration
 inifile:=TInifile.Create(Obtainininameuserconfig('','ibaccess','config'));
 try
  inifile.WriteBool('Userconfig','SystemConfig',Systemconfig);
  inifile.UpdateFile;
 finally
  inifile.free;
 end;
 dbconf.Systemconfig:=Systemconfig;
 dbconf.LoadAliases;
end;

procedure TFMain.ASystemdataExecute(Sender: TObject);
begin
 Systemconfig:=True;
 ASystemdata.Checked:=True;
 Auserdatabases.Checked:=false;
 SaveSystemconfig;
end;

procedure TFMain.AUserdatabasesExecute(Sender: TObject);
begin
 Systemconfig:=False;
 ASystemdata.Checked:=False;
 Auserdatabases.Checked:=True;
 SaveSystemconfig;
end;

procedure TFMain.ADatabaseconfExecute(Sender: TObject);
begin
 dbconf.ShowConfig(True,True,true);
end;

procedure TFMain.AExitExecute(Sender: TObject);
begin
 Close;
end;

procedure TFMain.ADropdatabaseExecute(Sender: TObject);
begin
 DeleteDatabase(username,password,dbconf);
end;

procedure TFMain.AHelpContentsExecute(Sender: TObject);
begin
// Htmlhelp1.ShowTableofContents;
end;

procedure TFMain.AHelpIndexExecute(Sender: TObject);
begin
// Htmlhelp1.ShowIndex;
end;

procedure TFMain.AHelpSearchExecute(Sender: TObject);
begin
// Htmlhelp1.ShowSearch;
end;

procedure TFMain.Cascade1Click(Sender: TObject);
begin
 Cascade;
end;

procedure TFMain.TileHorizontal1Click(Sender: TObject);
begin
// Tilemode:=tbHorizontal;
 Tile;
end;

procedure TFMain.TileVertical1Click(Sender: TObject);
begin
// Tilemode:=tbVertical;
 Tile;
end;

procedure TFMain.Arrange1Click(Sender: TObject);
begin
// Arrangeicons;
end;

procedure TFMain.About1Click(Sender: TObject);
begin
 ShowAbout;
end;

procedure TFMain.ARestoreExecute(Sender: TObject);
begin
 ibresto.ShowIBRestoreDialog(username,password,server,filename,protocol,dbconf);
end;

procedure TFMain.ABackupExecute(Sender: TObject);
begin
 BackupIBdatabase(username,password,role,server,filename,protocol,dbconf);
end;

procedure TFMain.ARepairExecute(Sender: TObject);
begin
 RepairIBdatabase(username,password,server,filename,protocol,dbconf);
end;

procedure TFMain.AStatisticsExecute(Sender: TObject);
begin
 ShowStatIBdatabase(username,password,server,filename,protocol,dbconf);
end;

procedure TFMain.ASerpropsExecute(Sender: TObject);
begin
 ShowServerIBprops(username,password,server,filename,protocol,dbconf);
end;

procedure TFMain.ADbpropsExecute(Sender: TObject);
begin
 ModifyIBdatabase(username,password,server,filename,protocol,dbconf);
end;

procedure TFMain.AUsersExecute(Sender: TObject);
begin
 ManageIBUsers(username,password,role,server,protocol,dbconf);
end;

procedure TFMain.FormDestroy(Sender: TObject);
begin
 dblist.free;
end;

procedure TFMain.Downgradedialect(Sender:TObject);
begin
 ShowMessage( SRpDialectDowngrade);
end;
 procedure TFMain.GridindowsDblClick(Sender: TObject);
begin
 // Opens the active row
 if Not (DWindows.Eof and DWindows.Bof) then
 begin
  TForm(DWindows.FieldByName('WINDOW').AsInteger).Show;
 end;
end;


procedure TFMain.DWindowsAfterDelete(DataSet: TDataSet);
begin
 PActiveW.Visible:=Not (DWindows.eof And DWindows.Bof);
end;

procedure TFMain.DWindowsAfterPost(DataSet: TDataSet);
begin
 PActiveW.Visible:=Not (DWindows.eof And DWindows.Bof);
end;


end.
