{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       Modify database form                            }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit modibase;

interface

uses
  SysUtils, Classes,QForms,variants,
  Db, ibman,IBDatabase,
  IBDatabaseInfo,  IBCustomDataSet, IBQuery,ibheader,
  ibintf,ib,ibacconst,diaser, rpibdb, IBServices,
  dbclient, QStdCtrls, QGrids, QDBGrids, QMask, QExtCtrls,
  QComCtrls, QControls, QDialogs, QButtons;

type
  TFMOdibase = class(TFService)
    PControl: TPageControl;
    TabFiles: TTabSheet;
    Tabprop: TTabSheet;
    BNouSec: TButton;
    GridArchi: TDBGrid;
    BNouSombra: TButton;
    GridSombra: TDBGrid;
    Checkforced: TCheckBox;
    BElimSom: TButton;
    IbMan1: TIbManager;
    DBInfo: TIBDatabaseInfo;
    BSetSweep: TButton;
    BSetCache: TButton;
    Label4: TLabel;
    QShadows: TIBQuery;
    QFiles: TIBQuery;
    Tran1: TIBTransaction;
    SShadows: TDataSource;
    SFiles: TDataSource;
    QFilesRDBFILE_NAME: TIBStringField;
    QFilesRDBFILE_SEQUENCE: TSmallintField;
    QFilesRDBFILE_START: TIntegerField;
    QShadowsRDBFILE_NAME: TIBStringField;
    QShadowsRDBFILE_SEQUENCE: TSmallintField;
    QShadowsRDBFILE_START: TIntegerField;
    QShadowsRDBSHADOW_NUMBER: TSmallintField;
    QShadowsRDBFILE_LENGTH: TIntegerField;
    QShadowsTamanyMbq: TIntegerField;
    QFilesRDBFILE_LENGTH: TIntegerField;
    QFilesTamanyMb: TIntegerField;
    GType: TGroupBox;
    RadioService: TRadioButton;
    RadioCommandline: TRadioButton;
    Label9: TLabel;
    Label10: TLabel;
    ComboDialect: TComboBox;
    GShut: TRadioGroup;
    Label11: TLabel;
    BShut: TButton;
    BOnline: TButton;
    dbase: TIBDatabase;
    IBConf: TIBConfigService;
    CheckReadonly: TCheckBox;
    DSecond: TClientdataset;
    DSecondFile: TStringField;
    DSecondSize: TIntegerField;
    DSecondSizeMb: TIntegerField;
    BSweep: TButton;
    IBVal: TIBValidationService;
    TabStat: TTabSheet;
    LSite: TLabel;
    Label8: TLabel;
    MINfo: TMemo;
    LINfo: TListBox;
    GInfo: TRadioGroup;
    GSize: TGroupBox;
    Label12: TLabel;
    LPageSize: TLabel;
    LPagecount: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    LSize: TLabel;
    GMemory: TGroupBox;
    Label20: TLabel;
    LTotalwrites: TLabel;
    Label19: TLabel;
    LTotalreads: TLabel;
    Label21: TLabel;
    LBuffers: TLabel;
    LEscrit: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    LMemory: TLabel;
    LMaxMemory: TLabel;
    LFeches: TLabel;
    GVersion: TGroupBox;
    LMajor: TLabel;
    Label13: TLabel;
    LVersion: TLabel;
    Label18: TLabel;
    Label14: TLabel;
    LBaseLevel: TLabel;
    Label15: TLabel;
    LImpClass: TLabel;
    LDialect: TLabel;
    Label16: TLabel;
    LImpno: TLabel;
    Label17: TLabel;
    Label26: TLabel;
    LReserve: TLabel;
    EInterval: TMaskEdit;
    EPagsCache: TMaskEdit;
    ESeconds: TMaskEdit;
    BStat: TButton;
    procedure CheckforcedClick(Sender: TObject);
    procedure BSetSweepClick(Sender: TObject);
    procedure BSetCacheClick(Sender: TObject);
    procedure PControlChange(Sender: TObject);
    procedure BNouSecClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BElimSomClick(Sender: TObject);
    procedure BNouSombraClick(Sender: TObject);
    procedure QShadowsCalcFields(DataSet: TDataSet);
    procedure QFilesAfterOpen(DataSet: TDataSet);
    procedure BOKClick(Sender: TObject);
    procedure EServerChange(Sender: TObject);
    procedure ComboProtocolChange(Sender: TObject);
    procedure EUsernameChange(Sender: TObject);
    procedure EPasswordChange(Sender: TObject);
    procedure EBaseChange(Sender: TObject);
    procedure BShutClick(Sender: TObject);
    procedure BOnlineClick(Sender: TObject);
    procedure ComboDialectClick(Sender: TObject);
    procedure CheckReadonlyClick(Sender: TObject);
    procedure BSweepClick(Sender: TObject);
    procedure LINfoClick(Sender: TObject);
    procedure GInfoClick(Sender: TObject);
    procedure BStatClick(Sender: TObject);
  private
    { Private declarations }
    anticparams:TStringlist;
    procedure FillFiles;
    procedure Connectdatabase;
    procedure CheckConnected;
    procedure UpdateIBCOnf;
    procedure Fillinfo;
  protected
    procedure OnConChange(Sender:TObject);override;
  public
    desconectat:boolean;
    { Public declarations }
  end;

procedure ModifyIBdatabase(var username,password,server,database:string;var protocol:TRpIBXProtocol;dbconf:TRpDBIBconf);

implementation

uses newdbfile, newshadow, ibproces, ibidxstat;


{$R *.xfm}

procedure ModifyIBdatabase(var username,password,server,database:string;var protocol:TRpIBXProtocol;dbconf:TRpDBIBconf);
var
 dia:TFModibase;
begin
 dia:=TFModibase.create(Application);
 try
  dia.Eusername.text:=username;
  dia.EPassword.text:=password;
  dia.EServer.text:=server;
  dia.dbconf:=dbconf;
  dia.EServerChange(dia);
  dia.EBase.text:=Database;
  dia.comboprotocol.itemindex:=integer(protocol);
  dia.Radiocommandline.checked:=ibman.globalusecommandline;
  dia.showmodal;
  if dia.executed then
  begin
   username:=dia.USername;
   password:=dia.Password;
   server:=dia.Server;
   database:=dia.database;
   protocol:=TRpIBXProtocol(dia.protocol);
  end;
 finally
  dia.free;
 end;
end;

procedure TFMOdibase.CheckforcedClick(Sender: TObject);
begin
  inherited;
 CheckForced.AllowGrayed:=false;
 if checkforced.State=cbGrayed then
  checkforced.State:=cbChecked;
 if RadioService.checked then
 begin
  UpdateIBConf;
  IBConf.Attach;
  try
   IBConf.SetAsyncMode(Not CheckForced.checked);
  finally
   try
    IBConf.Detach;
   except
   end;
  end;
 end
 else
 begin
  ibman1.serverpath:=ibman.globalserverpath;
  ibman1.Username:=Eusername.text;
  ibman1.Password:=EPassword.text;
  ibman1.Filename:=BuildIBDatabaseName((Length(Trim(EServer.text))>0),TRpIBXProtocol(ComboProtocol.ItemIndex),EServer.Text,EBase.text);
  ibman1.EnableForcedWrites(CheckForced.checked);
 end;
end;

procedure TFModibase.UpdateIBCOnf;
begin
 IBConf.Params.clear;
 IBConf.params.add('user_name='+EUsername.text);
 IBConf.params.add('password='+EPassword.text);
 IBConf.ServerName:=Trim(EServer.Text);
 IBConf.databasename:=EBase.text;
 if Length(IBConf.ServerName)=0 then
 begin
  IBConf.protocol:=Local;
 end
 else
 begin
  IBConf.protocol:=TProtocol(ComboProtocol.itemindex);
 end;
end;

procedure TFMOdibase.BSetSweepClick(Sender: TObject);
begin
 if RadioService.checked then
 begin
  UpdateIBConf;
  IBConf.Attach;
  try
   IBConf.SetSweepInterval(StrToInt(EInterval.Text));
  finally
   try
    IBConf.Detach;
   except
   end;
  end;
 end
 else
 begin
  ibman1.serverpath:=ibman.globalserverpath;
  ibman1.Username:=Eusername.text;
  ibman1.Password:=EPassword.text;
  ibman1.Filename:=BuildIBDatabaseName((Length(Trim(EServer.text))>0),TRpIBXProtocol(ComboProtocol.ItemIndex),EServer.Text,EBase.text);
  ibman1.SetSweepInterval(StrToInt(EInterval.Text));
 end;
end;

procedure TFMOdibase.BSetCacheClick(Sender: TObject);
begin
 dbase.connected:=false;
 if RadioService.checked then
 begin
  UpdateIBConf;
  IBConf.Attach;
  try
   IBConf.SetPageBuffers(StrToInt(EPAgsCache.Text));
  finally
   try
    IBConf.Detach;
   except
   end;
  end;
 end
 else
 begin
  ibman1.serverpath:=ibman.globalserverpath;
  ibman1.Username:=Eusername.text;
  ibman1.Password:=EPassword.text;
  ibman1.Filename:=BuildIBDatabaseName((Length(Trim(EServer.text))>0),TRpIBXProtocol(ComboProtocol.ItemIndex),EServer.Text,EBase.text);
  ibman1.SetCachePages(StrToInt(EPAgsCache.Text));
 end;
end;

procedure TFModibase.FillFiles;
begin
 LSite.caption:=DBInfo.DBSiteName;
 QFiles.Close;
 QShadows.Close;
 if Tran1.Intransaction then
  Tran1.Rollback;
 Tran1.Defaultdatabase:=dbase;
 Tran1.StartTransaction;
 try
  QFiles.Open;
  QShadows.Open;
 except
  tran1.rollback;
  RaisE;
 end;
end;

procedure TFMOdibase.PControlChange(Sender: TObject);
begin
 if PControl.activepage=TabFiles then
 begin
  FillFiles;
 end
 else
 begin
  if Assigned(Tran1) then
   if Tran1.intransaction then
    Tran1.rollback;
 end;
 if PControl.Activepage=TabStat then
 begin
  FIllInfo;
 end;
end;

procedure TFModibase.Fillinfo;
var
 tam:extended;
begin
 tam:=DBInfo.Allocation;
 tam:=tam*(DBInfo.PageSize/1024)/1024;
 LSize.caption:=FormatFloat('######,0.##',tam)+' Mbytes';
 LPageSize.caption:=FormatFloat('######,0.##',dbinfo.PageSize);
 LPagecount.caption:=FormatFloat('######,0.##',DBInfo.Allocation);
 if (DBInfo.NoReserve=0) then
  Lreserve.caption:=SRpYes
 else
  Lreserve.caption:=SRpNo;

 LImpClass.caption:=Inttostr(dbINfo.DBImplementationClass);
 LImpno.caption:=Inttostr(dbINfo.DBImplementationno);
 LDialect.caption:=Inttostr(dbINfo.DBSQLDialect);
 LMajor.caption:=IntTostr(dbinfo.ODSMAjorVersion)+'.'+IntTostr(dbinfo.ODSMinorVersion);
 LVersion.caption:=dbinfo.version;
 LBaseLevel.caption:=IntTostr(dbInfo.BaseLevel);

 LTotalreads.caption:=FormatFloat('##########,0',dbinfo.REads);
 LTotalwrites.caption:=FormatFloat('##########,0',dbinfo.Writes);
 LBuffers.caption:=FormatFloat('########,##0',dbinfo.NumBuffers);
 LMemory.caption:=FormatFloat('########,##0',dbinfo.currentmemory div 1024)+' Kbytes';
 LMaxMemory.caption:=FormatFloat('########,##0',dbinfo.Maxmemory div 1024)+' Kbytes';
 LFeches.caption:=FormatFloat('########,##0',dbinfo.Fetches);
 LEscrit.caption:=FormatFloat('########,##0',dbinfo.Marks);

 LInfo.itemindex:=0;
 LInfoClick(Self);
 Ginfo.itemindex:=0;
 GInfoClick(Self);
end;

procedure TFMOdibase.BNouSecClick(Sender: TObject);
var
 dia:TFNewSecfile;
 afilename:string;
 pags:integer;
 filenum:integer;
 oldtran:TIBTransaction;
 start:integer;
 alist:TStringlist;
begin
 dia:=TFNewSecfile.create(Application);
 try
  dia.LServer.caption:=DBInfo.DBSiteName;
  dia.LDatabase.caption:=DBInfo.DBFileName;
  // Busqum l'ultim +200000
  pags:=0;
  filenum:=2;
  afilename:=ChangeFileExt(DBInfo.DBFileName,'.GD2');
  QFiles.First;
  While Not QFiles.EOF do
  begin
   pags:=QFilesRDBFILE_START.AsInteger;
   afilename:=QFilesRDBFILE_NAME.AsString;
   inc(filenum);
   QFiles.Next;
  end;
  pags:=pags+(2000000 div ((dbinfo.pagesize) div 1024));
  if filenum>2 then
  begin
   if filenum>9 then
    afilename:=ChangeFileExt(DBInfo.DBFileName,'.G'+IntToStr(filenum))
   else
    afilename:=ChangeFileExt(DBInfo.DBFileName,'.GD'+IntToStr(filenum));
  end;
  dia.EFIlename.text:=afilename;
  dia.Epag.text:=IntToStr(pags);
  dia.showmodal;
  if dia.docreate then
  begin
   start:=StrToInt(dia.Epag.text);
   if MessageDlg(SRpAddSec,mtWarning,[mbYes,mbNo,mbcancel],0)=mrYes then
   begin
    anticparams.assign(tran1.params);
    oldtran:=dbase.defaulttransaction;
    try
     if tran1.intransaction then
      tran1.rollback;
     tran1.params.Clear;
     dbase.DefaultTransaction:=tran1;
     tran1.StartTransaction;
     try
      alist:=TStringlist.create;
      alist.add('ALTER DATABASE ADD FILE ''' +
       dia.EFilename.text + ''' STARTING AT PAGE ' +
       inttostr(start));
      try
       dbase.Call(
       isc_dsql_execute_immediate(StatusVector, @dbase.Handle, @tran1.handle, 0,
                                PChar(alist.strings[0]
                                ), dbase.SQLDialect, nil),
       True);
      finally
       alist.free;
      end;
      tran1.commit;
     except
      tran1.Rollback;
      raise;
     end;
    finally
     dbase.DefaultTransaction:=oldtran;
     tran1.defaultdatabase:=dbase;
     tran1.params.assign(anticparams);
     BOKClick(Self);
     FillFiles;
     PControl.Activepage:=tabfiles;
    end;
   end;
  end;
 finally
  dia.free;
 end;
end;

procedure TFMOdibase.FormCreate(Sender: TObject);
begin
 DSecond.createdataset;
 anticparams:=TStringlist.create;
 GShut.itemindex:=0;
end;

procedure TFMOdibase.FormDestroy(Sender: TObject);
begin
 anticparams.free;
end;

procedure TFMOdibase.BElimSomClick(Sender: TObject);
var
 astring:string;
 oldtran:TIBTransaction;
begin
 If (QShadows.EOF AND QShadows.BOF) then
  exit;
 astring:='DROP SHADOW '+QShadowsRDBSHADOW_NUMBER.asstring;
 anticparams.assign(tran1.params);
 oldtran:=dbase.defaulttransaction;
 try
  if tran1.intransaction then
   tran1.rollback;
  tran1.params.Clear;
  dbase.DefaultTransaction:=tran1;
  tran1.StartTransaction;
  try
   dbase.Call(
   isc_dsql_execute_immediate(StatusVector, @dbase.Handle, @tran1.handle, 0,
                             PChar(astring), dbase.SQLDialect, nil),
   True);
   tran1.commit;
  except
   tran1.Rollback;
   raise;
  end;
 finally
  dbase.DefaultTransaction:=oldtran;
  tran1.defaultdatabase:=dbase;
  tran1.params.assign(anticparams);
  BOKCLick(Self);
  FillFiles;
  PControl.Activepage:=tabfiles;
 end;
end;

procedure TFMOdibase.BNouSombraClick(Sender: TObject);
var
 dia:TFNewShadow;
 oldtran:TIBTransaction;
 snumber:integer;
 astring:string;
 primer:boolean;
begin
 dia:=TFNewShadow.create(Application);
 try
  dia.LServer.caption:=DBInfo.DBSiteName;
  dia.LBase.caption:=DBInfo.DBFileName;
  dia.pagesize:=DBInfo.PageSize;
  QShadows.First;
  snumber:=1;
  While Not QShadows.EOF do
  begin
   if QShadowsRDBSHADOW_NUMBER.AsInteger>=snumber then
    snumber:=QShadowsRDBSHADOW_NUMBER.AsInteger+1;
   QShadows.Next;
  end;
  dia.Eiden.text:=inttostr(snumber);
  dia.showmodal;
  if dia.docreate then
  begin
   anticparams.assign(tran1.params);
   oldtran:=dbase.defaulttransaction;
   try
    if tran1.intransaction then
     tran1.rollback;
    tran1.params.Clear;
    dbase.DefaultTransaction:=tran1;
    astring:='CREATE SHADOW '+dia.Eiden.text;
    if dia.RAutoman.itemindex=0 then
     astring:=astring+' AUTO '
    else
     astring:=astring+' MANUAL ';
    if dia.CheckCond.checked then
     astring:=astring+' CONDITIONAL ';
    with dia do
    begin
     DSecond.disablecontrols;
     try
      DSecond.first;
      primer:=true;
      While Not DSecond.eof do
      begin
       if not primer then
        astring:=astring+' FILE ';
       primer:=false;
       if Not DSecondSize.isnull then
        astring:=astring+''''+DSecondFile.AsString+''' LENGTH '+
         DSecondSize.asstring
       else
       astring:=astring+''''+DSecondFile.AsString+''' ';
       DSecond.next;
      end;
     finally
      DSecond.enablecontrols;
     end;
    end;
     tran1.StartTransaction;
    try
     dbase.Call(
     isc_dsql_execute_immediate(StatusVector, @dbase.Handle, @tran1.handle, 0,
                              PChar(astring), dbase.SQLDialect, nil),
     True);
     tran1.commit;
    except
     tran1.Rollback;
     raise;
    end;
   finally
    dbase.DefaultTransaction:=oldtran;
    tran1.defaultdatabase:=dbase;
    tran1.params.assign(anticparams);
    BOKClick(Self);
    FillFiles;
    PControl.Activepage:=tabfiles;
   end;
  end;
 finally
  dia.free;
 end;
end;

procedure TFMOdibase.QShadowsCalcFields(DataSet: TDataSet);
begin
 if Not QShadowsRDBFILE_LENGTH.isnull then
  QShadowsTamanyMbq.asinteger:=QShadowsRDBFILE_LENGTH.AsInteger*DBInfo.PageSize div (1024*1024);
end;

procedure TFMOdibase.QFilesAfterOpen(DataSet: TDataSet);
var
 antic,pagesize:integer;
 asize,numpages:variant;
 afile:string;
 primer:boolean;
procedure addfile;
begin
 DSecond.Append;
 try
  DSecondfile.asstring:=afile;
  DSecondsize.asvariant:=numpages;
  DSecondsizemb.asvariant:=asize;
  DSecond.post;
 except
  DSecond.cancel;
  Raise;
 end;
end;

begin
 DSecond.close;
 DSecond.Createdataset;
 pagesize:=DBInfo.PageSize;
 DSecond.disablecontrols;
 try
  antic:=0;
  afile:=DBInfo.DBFileName;
  primer:=true;
  QFiles.First;
  While Not QFiles.EOF do
  begin
   if not primer then
    QFiles.next;
   primer:=false;
   if Not QFiles.EOF then
   begin
    if NOt QFilesRDBFILE_START.isnull then
    begin
     numpages:=QFilesRDBFILE_START.asinteger-antic-1;
     asize:=numpages*pagesize div (1024*1024);
     antic:=QFilesRDBFILE_START.asinteger;
    end
    else
    begin
     numpages:=QFilesRDBFILE_LENGTH.AsInteger-antic;
     asize:=(numpages*DBInfo.PageSize) div (1024*1024);
     antic:=QFilesRDBFILE_LENGTH.AsInteger+antic;
    end;
    addfile;
    afile:=QFilesRDBFILE_NAME.AsString;
   end;
  end;
  asize:=null;
  numpages:=null;
  addfile;
 finally
  DSecond.EnableControls;
 end;
end;

procedure TFMOdibase.BOKClick(Sender: TObject);
begin
  inherited;
 CheckConnected;
 dbinfo.database:=dbase;
 Checkforced.onclick:=nil;
 CheckForced.checked:=(dbinfo.ForcedWrites=1);
 Checkforced.onclick:=CheckForcedCLick;
 CheckReadonly.onclick:=nil;
 CheckReadonly.checked:=(dbinfo.ReadOnly=1);
 CheckReadonly.onclick:=CheckReadonlyCLick;
 EInterval.text:=Inttostr(dbinfo.SweepInterval);
 EPagscache.text:=Inttostr(dbinfo.NumBuffers);
 case dbase.sqldialect of
  1:
   Combodialect.itemindex:=0;
  else
   Combodialect.itemindex:=1;
 end;
 PControl.Activepage:=tabprop;
 PControl.visible:=true;

end;

procedure TFModibase.Connectdatabase;
begin
 dbase.connected:=False;
 dbase.Params.clear;
 dbase.sqldialect:=3;
 dbase.databasename:=BuildIBDatabaseName((Length(Trim(EServer.text))>0),TRpIBXProtocol(ComboProtocol.ItemIndex),EServer.Text,EBase.text);
 dbase.params.add('user_name='+EUsername.text);
 dbase.params.add('password='+EPassword.text);
 dbase.connected:=true;
end;

procedure TFModibase.CheckConnected;
begin
 if dbase.connected then
  exit;
 connectdatabase;
end;

procedure TFMOdibase.EServerChange(Sender: TObject);
begin
  inherited;
 dbase.connected:=false;
end;

procedure TFMOdibase.ComboProtocolChange(Sender: TObject);
begin
  inherited;
 dbase.connected:=false;

end;

procedure TFMOdibase.EUsernameChange(Sender: TObject);
begin
  inherited;
 dbase.connected:=false;

end;

procedure TFMOdibase.EPasswordChange(Sender: TObject);
begin
  inherited;
 dbase.connected:=false;

end;

procedure TFMOdibase.EBaseChange(Sender: TObject);
begin
  inherited;
 dbase.connected:=false;

end;

procedure TFMOdibase.BShutClick(Sender: TObject);
begin
  inherited;
 dbase.connected:=false;
 if RadioService.checked then
 begin
  UpdateIBConf;
  IBConf.Attach;
  try
   IBConf.ShutdownDatabase(TShutdownmode(GShut.Itemindex),StrToInt(ESeconds.text));
  finally
   try
    IBConf.Detach;
   except
   end;
  end;
 end
 else
 begin
  ibman1.serverpath:=ibman.globalserverpath;
  ibman1.Username:=Eusername.text;
  ibman1.Password:=EPassword.text;
  ibman1.Filename:=BuildIBDatabaseName((Length(Trim(EServer.text))>0),TRpIBXProtocol(ComboProtocol.ItemIndex),EServer.Text,EBase.text);
  ibman1.Shutdownoption:=TShutdownOption(GShut.itemindex);
  ibman1.Shutdownseconds:=StrToInt(ESeconds.text);
  ibman1.Shutdown;
 end;
end;

procedure TFMOdibase.BOnlineClick(Sender: TObject);
begin
  inherited;
 if RadioService.checked then
 begin
  UpdateIBConf;
  IBConf.Attach;
  try
   IBConf.BringDatabaseOnline;
  finally
   try
    IBConf.Detach;
   except
   end;
  end;
 end
 else
 begin
  ibman1.serverpath:=ibman.globalserverpath;
  ibman1.Username:=Eusername.text;
  ibman1.Password:=EPassword.text;
  ibman1.Filename:=BuildIBDatabaseName((Length(Trim(EServer.text))>0),TRpIBXProtocol(ComboProtocol.ItemIndex),EServer.Text,EBase.text);
  ibman1.BringOnline;
 end;
end;

procedure TFMOdibase.ComboDialectClick(Sender: TObject);
var
 dialect:integer;
begin
  inherited;
 dbase.connected:=false;
 if ComboDialect.itemindex=0 then
  dialect:=1
 else
  dialect:=3;
 if RadioService.checked then
 begin
  UpdateIBConf;
  IBConf.Attach;
  try
   IBConf.SetDBSqlDialect(dialect);
  finally
   try
    IBConf.Detach;
   except
   end;
  end;
 end
 else
 begin
  ibman1.serverpath:=ibman.globalserverpath;
  ibman1.Username:=Eusername.text;
  ibman1.Password:=EPassword.text;
  ibman1.Filename:=BuildIBDatabaseName((Length(Trim(EServer.text))>0),TRpIBXProtocol(ComboProtocol.ItemIndex),EServer.Text,EBase.text);
  ibman1.SetSQLDialect(dialect);
 end;
end;

procedure TFMOdibase.CheckReadonlyClick(Sender: TObject);
begin
  inherited;
 dbase.connected:=false;
 CheckReadonly.AllowGrayed:=false;
 if checkreadonly.State=cbGrayed then
  checkreadonly.State:=cbChecked;
 if RadioService.checked then
 begin
  UpdateIBConf;
  IBConf.Attach;
  try
   IBConf.SetReadOnly(CheckReadonly.checked);
  finally
   try
    IBConf.Detach;
   except
   end;
  end;
 end
 else
 begin
  ibman1.serverpath:=ibman.globalserverpath;
  ibman1.Username:=Eusername.text;
  ibman1.Password:=EPassword.text;
  ibman1.Filename:=BuildIBDatabaseName((Length(Trim(EServer.text))>0),TRpIBXProtocol(ComboProtocol.ItemIndex),EServer.Text,EBase.text);
  ibman1.SetReadonly(CheckReadonly.checked);
 end;
end;

procedure TFMOdibase.BSweepClick(Sender: TObject);
begin
  inherited;
 if RadioService.checked then
 begin
  IBVal.Params.clear;
  IBVal.params.add('user_name='+EUsername.text);
  IBVal.params.add('password='+EPassword.text);
  IBVal.ServerName:=Trim(EServer.Text);
  IBVal.databasename:=EBase.text;
  if Length(IBVal.ServerName)=0 then
  begin
   IBVal.protocol:=Local;
  end
  else
  begin
   IBVal.protocol:=TProtocol(ComboProtocol.itemindex);
  end;
  IBVal.Options:=[SweepDB];
  IBVal.Attach;
  try
   IBvAL.ServiceStart;
   ibproces.COntrolIBService(IBVal);
  finally
   try
    IBVal.Detach;
   except
   end;
  end;
 end
 else
 begin
  ibman1.serverpath:=ibman.globalserverpath;
  ibman1.Username:=Eusername.text;
  ibman1.Password:=EPassword.text;
  ibman1.Filename:=BuildIBDatabaseName((Length(Trim(EServer.text))>0),TRpIBXProtocol(ComboProtocol.ItemIndex),EServer.Text,EBase.text);
  ibman1.Sweep;
 end;
end;

procedure TFMOdibase.LINfoClick(Sender: TObject);
begin
  inherited;
 case LInfo.itemindex of
  0:
   Minfo.lines.assign(dbinfo.UserNames);
  1:
   Minfo.lines.assign(dbinfo.DeleteCount);
  2:
   Minfo.lines.assign(dbinfo.ExpungeCount);
  3:
   Minfo.lines.assign(dbinfo.BackoutCount);
  4:
   Minfo.lines.assign(dbinfo.InsertCount);
  5:
   Minfo.lines.assign(dbinfo.PurgeCount);
  6:
   Minfo.lines.assign(dbinfo.ReadIdxCount);
  7:
   Minfo.lines.assign(dbinfo.ReadSeqCount);
  8:
   Minfo.lines.assign(dbinfo.Updatecount);
 end;
end;

procedure TFMOdibase.GInfoClick(Sender: TObject);
begin
  inherited;
 GSize.Visible:=False;
 GVersion.Visible:=False;
 GMemory.visible:=false;
 case GInfo.Itemindex of
  0:
   GSize.Visible:=true;
  1:
   GMemory.visible:=true;
  2:
   GVersion.Visible:=true;
 end;
end;

procedure TFModibase.OnConChange(Sender:TObject);
begin
 inherited;
 dbase.connected:=false;
 PCOntrol.visible:=false;
end;

procedure TFMOdibase.BStatClick(Sender: TObject);
begin
  inherited;
 if (not dbase.connected) then
  dbase.connected:=true;
 ibrecomputeindexstat(dbase,'','');
end;

end.
