{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       New exception and alter exception form          }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit newexception;

interface

uses Classes, variants,QForms,SysUtils, QStdCtrls, QControls,
  IBSql, IBDatabase,ibutil2,ibacconst;

type
  TFNewException = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Label1: TLabel;
    EException: TEdit;
    Label2: TLabel;
    EMessage: TEdit;
    procedure OKBtnClick(Sender: TObject);
  private
    { Private declarations }
    docreate:boolean;
  public
    { Public declarations }
    base:TIBDatabase;
  end;


function IBNewException(base:TIBDatabase):boolean;
procedure IBDropException(base:TIBDatabase;exception:string);
function IBAlterException(base:TIBDatabase;exception:string):boolean;

implementation

{$R *.xfm}


procedure IBDropException(base:TIBDatabase;exception:string);
begin
 IBExecuteSQL(base,'DROP EXCEPTION "'+exception+'"');
end;

function IBNewException(base:TIBDatabase):boolean;
var
 dia:TFNewException;
begin
 dia:=TFNewException.create(Application);
 try
  dia.base:=base;
  dia.showmodal;
  Result:=dia.docreate;
 finally
  dia.free;
 end;
end;

function IBAlterException(base:TIBDatabase;exception:string):boolean;
var
 dia:TFNewException;
 avalue:variant;
 aquery:string;
begin
 dia:=TFNewException.create(Application);
 try
  dia.base:=base;
  dia.caption:=SrpALterException;
  dia.EException.text:=exception;
  dia.EException.readonly:=true;
//  dia.eexception.color:=clinfobk;
  dia.activecontrol:=dia.EMessage;
  aquery:='SELECT RDB$MESSAGE FROM RDB$EXCEPTIONS '+
   ' WHERE RDB$EXCEPTION_NAME='+QuotedStr(exception);
  avalue:=IBObtainValueFromSQL(base,aquery);
  if avalue<>null then
   dia.EMessage.text:=avalue;
  Result:=dia.showmodal=mrok;
 finally
  dia.free;
 end;
end;


procedure TFNewException.OKBtnClick(Sender: TObject);
var
 adeli:String;
begin
 adeli:='';
 if base.sqldialect=3 then
  adeli:='"';
 if EException.readonly then
  IBExecuteSQL(base,'ALTER EXCEPTION '+adeli+EException.text+adeli+' '+
   QuotedStr(EMessage.text))
 else
  IBExecuteSQL(base,'CREATE EXCEPTION '+adeli+EException.text+adeli+' '+
   QuotedStr(EMessage.text));
 docreate:=true;
end;

end.
