{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       New grant wizard                                }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit newgrant;

interface

uses Classes, QForms, SysUtils,
  Db, IBDatabase, IBSQL,
  ibacutils,ibacconst, ibman,rpibdb, DBClient, QStdCtrls, QButtons,
  QControls, QExtCtrls;

type
  TFNewgrant = class(TForm)
    DBObjects: TClientdataset;
    DBObjectsNAME: TStringField;
    CheckGrant: TCheckBox;
    LObjectgrant: TLabel;
    ComboObjectdest: TComboBox;
    ComboObjectType: TComboBox;
    Label6: TLabel;
    GColumns: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    LAval: TListBox;
    BADD: TBitBtn;
    BRemove: TBitBtn;
    LSelected: TListBox;
    ComboObject: TComboBox;
    Label2: TLabel;
    LPriv: TLabel;
    ComboPriv: TComboBox;
    ComboGrant: TComboBox;
    Label5: TLabel;
    BSelectFields: TButton;
    CancelBtn: TButton;
    OKBtn: TButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    IBSQL1: TIBSQL;
    Trans: TIBTransaction;
    procedure FormCreate(Sender: TObject);
    procedure BADDClick(Sender: TObject);
    procedure BRemoveClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ComboGrantClick(Sender: TObject);
    procedure ComboObjectDropDown(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ComboObjectTypeClick(Sender: TObject);
    procedure ComboObjectdestDropDown(Sender: TObject);
    procedure BSelectFieldsClick(Sender: TObject);
    procedure ComboObjectChange(Sender: TObject);
    procedure ComboPrivClick(Sender: TObject);
  private
    { Private declarations }
    tablename:string;
    fieldlist:TStringlist;
    validobjects:boolean;
    validgrant:boolean;
    dook:boolean;
    procedure fillavalfields(dia:TFFetching);
    procedure DoGrant;
    function buildtable:string;
    function buildprocedure:string;
    function buildrole:string;
    procedure Updatecolumns;
  public
    { Public declarations }
    base:TIBDatabase;
    user,password,server:string;
    protocol:TRpIBXProtocol;
  end;


function IBNewgrant(base:TIBDatabase;user,password,server:string;protocol:TRpIBXProtocol):boolean;

implementation

uses ibutil2;

{$R *.xfm}
function IBNewgrant(base:TIBDatabase;user,password,server:string;protocol:TRpIBXProtocol):boolean;
var
 dia:TFNewgrant;
begin
 dia:=TFNewgrant.create(application);
 try
  dia.base:=base;
  dia.trans.defaultdatabase:=base;
  dia.user:=user;
  dia.password:=password;
  dia.server:=server;
  dia.protocol:=protocol;
  dia.IBSQL1.database:=base;
  result:=dia.showmodal=mrok;
 finally
  dia.free;
 end;
end;

procedure TFNewgrant.fillavalfields(dia:TFFetching);
begin
 Trans.starttransaction;
 try
  IBSQL1.sql.text:='SELECT RDB$FIELD_NAME FROM RDB$RELATION_FIELDS '+
   ' WHERE RDB$RELATION_NAME='''+tablename+''' ORDER BY RDB$FIELD_POSITION';
  IBSQL1.ExecQuery;
  try
   While Not IBSQL1.EOF do
   begin
    Fieldlist.add(IBSQL1.FieldByName('RDB$FIELD_NAME').AsString);
    IBSQL1.Next;
    dia.IncFetch(1);
   end;
  finally
   IBSQL1.CLose;
  end;
 finally
  trans.rollback;
 end;
 LAval.items.assign(Fieldlist);
 LSelected.items.clear;
 if fieldlist.count>0 then
 begin
  LAval.itemindex:=0;
 end;
end;


procedure TFNewgrant.FormCreate(Sender: TObject);
begin
 DBObjects.CreateDataSet;
 fieldlist:=TStringlist.create;
// SendMessage(LAval.Handle,LB_SETHORIZONTALEXTENT,512,0);
 //SendMessage(LSelected.Handle,LB_SETHORIZONTALEXTENT,512,0);
 //SendMessage(ComboObjectdest.Handle,CB_SETDROPPEDWIDTH,300,0);
 //SendMessage(ComboObject.Handle,CB_SETDROPPEDWIDTH,300,0);
 ComboGrant.itemindex:=0;
 ComboObjecttype.itemindex:=2;
 ComboPriv.itemindex:=0;
end;

procedure TFNewgrant.BADDClick(Sender: TObject);
begin
 if LAval.items.count<1 then
  exit;
 if lAval.itemindex<0 then
  exit;
 LSelected.Items.Add(laval.items.strings[laval.itemindex]);
 LAval.items.delete(laval.itemindex);
 if LSelected.items.count=1 then
  LSelected.itemindex:=0;
 if LAval.items.count>0 then
  LAval.itemindex:=0;
end;

procedure TFNewgrant.BRemoveClick(Sender: TObject);
var
 oldaval:string;
 alist:TStringlist;
 i,index:integer;
begin
 if LSelected.items.count<1 then
  exit;
 if lSelected.itemindex<0 then
  exit;
 index:=lselected.itemindex;
 LSelected.items.delete(lselected.itemindex);
 if LSelected.items.count>0 then
  LSelected.itemindex:=index;
 // Restores all the fields to position the field
 alist:=TStringlist.create;
 try
  oldaval:='';
  if LAval.itemindex>=0 then
   oldaval:=LAval.items.strings[laval.itemindex];
  alist.assign(fieldlist);
  for i:=0 to LSelected.items.count-1 do
  begin
   index:=alist.indexof(LSelected.items.strings[i]);
   if index>=0 then
    alist.delete(index);
  end;
  LAval.items.assign(alist);
  index:=laval.items.indexof(oldaval);
  if index>=0 then
   Laval.itemindex:=index;
 finally
  alist.free;
 end;
end;

procedure TFNewgrant.FormDestroy(Sender: TObject);
begin
 fieldlist.free;
end;

procedure TFNewgrant.ComboGrantClick(Sender: TObject);
begin
 Lpriv.visible:=combogrant.itemindex=0;
 ComboPriv.visible:=combogrant.itemindex=0;
 BSelectFields.visible:=combogrant.itemindex=0;
 validobjects:=false;
 GColumns.visible:=false;
 // Insert the items on Combo Priv
 with Combopriv.items do
 begin
  clear;
  add(SRpAllprivileges);
  add(SRpSelect);
  add(SRpDelete);
  Add(SRpInsert);
  Add(SrpUpdate);
  Add(SrpReferences);
  ComboPriv.itemindex:=0;
 end;
 BSelectFields.Visible:=(ComboPriv.itemindex in [4,5]) AND (Combogrant.itemindex=0);
 GColumns.visible:=False;
end;

procedure TFNewgrant.ComboObjectDropDown(Sender: TObject);
var
 astring:string;
begin
 if validobjects then
  exit;
 ComboObject.items.clear;
 Case ComboGrant.itemindex of
  0:
   begin
    astring:='SELECT RDB$RELATION_NAME FROM RDB$RELATIONS WHERE '+
     ' ((RDB$SYSTEM_FLAG=0) OR (RDB$SYSTEM_FLAG IS NULL)) ORDER BY '+
     ' RDB$RELATION_NAME ';
   end;
  1:
   begin
    astring:='SELECT RDB$PROCEDURE_NAME FROM RDB$PROCEDURES WHERE '+
     ' ((RDB$SYSTEM_FLAG=0) OR (RDB$SYSTEM_FLAG IS NULL)) ORDER BY '+
     ' RDB$PROCEDURE_NAME ';
   end;
  else
   begin
    astring:='SELECT RDB$ROLE_NAME FROM RDB$ROLES '+
     ' ORDER BY RDB$ROLE_NAME ';
   end;
 end;
 Trans.StartTransaction;
 try
  IBSQL1.SQL.text:=astring;
  IBSQL1.ExecQuery;
  While Not IBSQl1.EOF do
  begin
   ComboObject.items.add(IBSQL1.Fields[0].AsString);
   IBSQL1.Next;
  end;
  validobjects:=True;
 finally
  Trans.Rollback;
 end;
end;

procedure TFNewgrant.OKBtnClick(Sender: TObject);
begin
 dook:=True;
end;

function TFNewgrant.buildtable:string;
var
 afields:string;
 i:integeR;
 adeli:string;
begin
 adeli:='';
 if base.sqldialect=3 then
  adeli:='"';
 Result:='GRANT '+Combopriv.text;
 if (Combopriv.itemindex in [4,5]) then
 begin
  if GColumns.visible then
  begin
   if LSelected.items.count>0 then
   begin
    afields:='';
    for i:=0 to LSelected.items.count-1 do
    begin
     if Length(afields)>0 then
      afields:=afields+','+adeli+lselected.items.strings[i]+adeli
     else
      afields:='('+adeli+lselected.items.strings[i]+adeli;
    end;
    afields:=afields+')';
    Result:=Result+' '+afields+' ';
   end;
  end;
 end;
 Result:=Result+' ON ';
 Result:=Result+adeli+ComboObject.text+ adeli+' TO ';
 case ComboObjectType.ItemIndex of
  0:
   Result:=Result+' PUBLIC';
  1,2:
   Result:=Result+' '+adeli+ComboObjectdest.text+adeli;
  3,4,5:
   Result:=Result+' '+ComboObjectType.text+' '+adeli+ComboObjectdest.text+adeli;
 end;
 if Checkgrant.Visible then
  if Checkgrant.checked then
   Result:=Result+ ' WITH GRANT OPTION';
end;

function TFNewgrant.buildprocedure:string;
var
 adeli:string;
begin
 adeli:='';
 if base.sqldialect=3 then
  adeli:='"';
 Result:='GRANT EXECUTE ON PROCEDURE '+adeli+ComboObject.text+adeli+' TO ';
 case ComboObjectType.ItemIndex of
  0:
   Result:=Result+' PUBLIC';
  1,2:
   Result:=Result+' '+adeli+ComboObjectdest.text+adeli;
  3,4,5:
   Result:=Result+' '+ComboObjectType.text+' '+adeli+ComboObjectdest.text+adeli;
 end;
 if Checkgrant.Visible then
  if Checkgrant.checked then
   Result:=Result+ ' WITH GRANT OPTION';
end;

function TFNewgrant.buildrole:string;
var
 adeli:string;
begin
 adeli:='';
 if base.sqldialect=3 then
  adeli:='"';
 Result:='GRANT '+adeli+ComboObject.text+adeli+' TO '+adeli+ComboObjectdest.text+adeli;
 if Checkgrant.Visible then
  if Checkgrant.checked then
   Result:=Result+ ' WITH ADMIN OPTION';
end;

procedure TFNewgrant.DoGrant;
var
 astring:string;
begin
 if length(Trim(ComboObject.text))<1 then
  Raise Exception.create(SRpSelectDBObject);
 if length(Trim(ComboObjectdest.text))<1 then
  Raise Exception.create(SRpGrantObject);
 // Grant privileges
 case Combogrant.itemindex of
  0:
   astring:=Buildtable;
  1:
   astring:=Buildprocedure;
  2:
   astring:=BuildRole;
 end;
 trans.starttransaction;
 try
  IBSQL1.sql.text:=astring;
  IBSQL1.ExecQuery;
  trans.commit;
 except
  trans.rollback;
  raise;
 end;
end;

procedure TFNewgrant.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
 try
  if dook then
   DoGrant;
 finally
  dook:=false;
 end;
end;

procedure TFNewgrant.ComboObjectTypeClick(Sender: TObject);
begin
 validgrant:=false;
 // Visible or invisible
 case ComboObjectType.itemindex of
  1..5:
   begin
    LObjectgrant.visible:=True;
    ComboObjectdest.visible:=True;
   end;
  else
   begin
    LObjectgrant.visible:=False;
    ComboObjectdest.visible:=False;
   end;
 end;
 case ComboObjectType.itemindex of
  1..2:
   begin
    LObjectgrant.visible:=True;
    ComboObjectdest.visible:=True;
    CheckGrant.Visible:=True;
   end;
  else
   begin
    CheckGrant.Visible:=false;
   end;
 end;
end;

procedure TFNewgrant.ComboObjectdestDropDown(Sender: TObject);
var
 astring:string;
 twofields:boolean;
begin
 if validgrant then
  exit;
 twofields:=false;
 ComboObjectdest.items.clear;
 case ComboObjectType.itemindex of
  1:
   begin
    astring:='';
    FillWithUsers(user,password,server,protocol,comboobjectdest.items);
    validgrant:=true;
   end;
  2:
   begin
    astring:='SELECT RDB$ROLE_NAME FROM RDB$ROLES '+
     ' ORDER BY RDB$ROLE_NAME ';
   end;
  3:
   begin
    astring:='SELECT RDB$PROCEDURE_NAME FROM RDB$PROCEDURES WHERE '+
     ' ((RDB$SYSTEM_FLAG=0) OR (RDB$SYSTEM_FLAG IS NULL)) ORDER BY '+
     ' RDB$PROCEDURE_NAME ';
   end;
  4:
   begin
    astring:='SELECT RDB$RELATION_NAME,RDB$TRIGGER_NAME FROM RDB$TRIGGERS WHERE '+
     ' ((RDB$SYSTEM_FLAG=0) OR (RDB$SYSTEM_FLAG IS NULL)) ORDER BY '+
     ' RDB$TRIGGER_NAME ';
    twofields:=true;
   end;
  5:
   begin
    astring:='SELECT RDB$RELATION_NAME FROM RDB$RELATIONS WHERE '+
     ' ((RDB$SYSTEM_FLAG=0) OR (RDB$SYSTEM_FLAG IS NULL)) '+
     ' AND (NOT (RDB$VIEW_SOURCE IS NULL)) ORDER BY '+
     ' RDB$RELATION_NAME ';
   end;
  else
  begin
   astring:='';
  end;
 end;
 if astring='' then
  exit;
 Trans.StartTransaction;
 try
  IBSQL1.SQL.text:=astring;
  IBSQL1.ExecQuery;
  While Not IBSQl1.EOF do
  begin
   if twofields then
    ComboObjectdest.items.add({IBSQL1.Fields[0].AsString+'.'+}IBSQL1.Fields[1].AsString)
   else
    ComboObjectdest.items.add(IBSQL1.Fields[0].AsString);
   IBSQL1.Next;
  end;
  validgrant:=True;
 finally
  Trans.Rollback;
 end;
end;

procedure TFNewgrant.BSelectFieldsClick(Sender: TObject);
begin
 Updatecolumns;
end;

procedure TFNewGrant.Updatecolumns;
begin
 tablename:=ComboObject.text;
 ExecuteActionProgres(fillavalfields,true,nil);
 if fieldlist.count>0 then
  GColumns.visible:=True;
end;

procedure TFNewgrant.ComboObjectChange(Sender: TObject);
begin
 GColumns.visible:=false;
end;

procedure TFNewgrant.ComboPrivClick(Sender: TObject);
begin
 BSelectFields.Visible:=(ComboPriv.itemindex in [4,5]);
 GColumns.visible:=False;
end;

end.
