{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       User config dialog                              }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit usernameform;

interface

uses Classes, QForms, inifiles,rpshfolder, QStdCtrls, QControls, QComCtrls,
 ibman;

type
  TFUsername = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    PControl: TPageControl;
    Tabcon: TTabSheet;
    TabSheet2: TTabSheet;
    Label3: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    EPassword: TEdit;
    EUser: TEdit;
    CheckRemember: TCheckBox;
    ComboChar: TComboBox;
    Erole: TEdit;
    CheckFastquerys: TCheckBox;
    CheckBidiquerys: TCheckBox;
    CheckShowStat: TCheckBox;
    CheckShowplan: TCheckBox;
    CheckSaveHistory: TCheckBox;
    CheckCommitDDL: TCheckBox;
    TabTables: TTabSheet;
    Checkgridedition: TCheckBox;
    CheckAutocommitt: TCheckBox;
    CheckResync: TCheckBox;
    Checkreadonly: TCheckBox;
    Checkparamcheck: TCheckBox;
    TabDomain: TTabSheet;
    CheckSystemdomains: TCheckBox;
    CheckAutorefresh: TCheckBox;
    CheckSystemdata: TCheckBox;
    CheckDetails: TCheckBox;
    Label1: TLabel;
    EServerpath: TEdit;
    Checkcommandline: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    { Private declarations }
    procedure Writeconfig;
  public
    { Public declarations }
  end;


implementation

uses mainform, ibacutils,ibexecsql,tablenew,databaseform;

{$R *.xfm}

procedure TFUsername.FormShow(Sender: TObject);
begin
 // Reads the configuration from main form
 EUser.text:=fmain.username;
 EPassword.text:=fmain.password;
 Checkremember.checked:=fmain.rememberpassword;
 ComboChar.itemindex:=Combochar.items.indexof(fmain.charset);
 ERole.text:=fmain.role;
 with fmain do
 begin
  // Server path
  EServerpath.text:=ibman.globalserverpath;
  // FExecSQL preferences
  CheckFastquerys.checked:=fspfastq in execsqlprefs;
  CheckParamcheck.checked:=fspparamcheck in execsqlprefs;
  CheckBidiquerys.checked:=fspbidiq in execsqlprefs;
  CheckShowStat.checked:=fspshowstat in execsqlprefs;
  CheckShowplan.checked:=fspqplan in execsqlprefs;
  CheckSaveHistory.checked:=fspsaveh in execsqlprefs;
  CheckCommitDDL.checked:=fspcommitddl in execsqlprefs;

  // FNewtable prefs
  CheckAutocommitt.checked:=fetautocommit in edittableprefs;
  Checkgridedition.checked:=fetgridedit in edittableprefs;
  CheckResync.checked:=fetresync in edittableprefs;
  Checkreadonly.checked:=fetopenreadonly in edittableprefs;

  // FDataabaseprefs
  CheckAutorefresh.checked:=fedAutorefresh in databaseprefs;
  CheckSystemdomains.checked:=fedsystemdomains in databaseprefs;
  CheckDetails.checked:=fedDetails in databaseprefs;
  CheckSystemdata.checked:=fedsystemdata in databaseprefs;

  CheckCommandline.checked:=ibman.globalusecommandline;
 end;
end;

procedure TFUsername.OKBtnClick(Sender: TObject);
begin
 Writeconfig;
 close;
end;

procedure TFUsername.Writeconfig;
var
 inifile:TInifile;
begin
 // Reads the user configuration
 inifile:=TInifile.Create(Obtainininameuserconfig('','ibaccess','config'));
 try
  ibman.globalserverpath:=EServerpath.text;
  inifile.WriteString('Userconfig','ServerPath',EServerpath.text);
  inifile.WriteString('Userconfig','Username',Euser.text);
  if Checkremember.checked then
   inifile.WriteString('Userconfig','Password',EPassword.text)
  else
   inifile.WriteString('Userconfig','Password','');
  inifile.WriteBool('Userconfig','RememberPassword',Checkremember.checked);
  inifile.WriteString('Userconfig','Charset',ComboChar.text);
  inifile.WriteString('Userconfig','Role',Erole.text);
  fmain.username:=EUser.text;
  fmain.password:=EPassword.text;
  fmain.rememberpassword:=Checkremember.checked;
  fmain.role:=ERole.text;

  with fmain do
  begin
   // FExecSQL preferences
   execsqlprefs:=[];
   inifile.WriteBool('ExecSQLprefs','FastQuerys',CheckFastquerys.checked);
   if CheckFastquerys.checked then
    include(execsqlprefs,fspfastq);
   inifile.WriteBool('ExecSQLprefs','ParamCheck',CheckParamcheck.checked);
   if CheckparamCheck.checked then
    include(execsqlprefs,fspparamcheck);
   inifile.WriteBool('ExecSQLprefs','BidiQuerys',CheckBidiquerys.checked);
   if CheckBidiquerys.checked then
    include(execsqlprefs,fspbidiq);
   inifile.WriteBool('ExecSQLprefs','ShowStat',CheckShowStat.checked);
   if CheckShowStat.checked then
    include(execsqlprefs,fspshowstat);
   inifile.WriteBool('ExecSQLprefs','ShowQPlan',CheckShowplan.checked);
   if CheckShowplan.checked then
    include(execsqlprefs,fspqplan);
   inifile.WriteBool('ExecSQLprefs','SaveHistory',CheckSaveHistory.checked);
   if CheckSaveHistory.checked then
    include(execsqlprefs,fspsaveh);
   inifile.WriteBool('ExecSQLprefs','CommitDLL',CheckCommitDDL.checked);
   if CheckCommitDDL.checked then
    include(execsqlprefs,fspcommitddl);

   // FNewtable prefs
   edittableprefs:=[];
   inifile.WriteBool('EditTableprefs','Autocommit',CheckAutocommitt.checked);
   if CheckAutocommitt.checked then
    include(edittableprefs,fetautocommit);
   inifile.WriteBool('EditTableprefs','Gridedition',Checkgridedition.checked);
   if Checkgridedition.checked then
    include(edittableprefs,fetgridedit);
   inifile.WriteBool('EditTableprefs','ResyncRecord',CheckResync.checked);
   if CheckResync.checked then
    include(edittableprefs,fetresync);
   inifile.WriteBool('EditTableprefs','Readonly',Checkreadonly.checked);
   if Checkreadonly.checked then
    include(edittableprefs,fetopenreadonly);

   // FDatabase prefs
   databaseprefs:=[];
   if CheckSystemdomains.checked then
    include(databaseprefs,fedsystemdomains);
   inifile.WriteBool('Databaseprefs','Systemdomains',CheckSystemdomains.checked);
   if CheckAutorefresh.checked then
    include(databaseprefs,fedautorefresh);
   inifile.WriteBool('Databaseprefs','Autorefresh',CheckAutorefresh.checked);
   if CheckSystemdata.checked then
    include(databaseprefs,fedsystemdata);
   inifile.WriteBool('Databaseprefs','Systemdata',CheckSystemdata.checked);
   if CheckDetails.checked then
    include(databaseprefs,feddetails);
   inifile.WriteBool('Databaseprefs','Details',CheckDetails.checked);
   ibman.globalusecommandline:=CheckCommandline.checked;
   inifile.WriteBool('User config','Commandline',CheckCommandline.checked);
  end;
  inifile.UpdateFile;
 finally
  inifile.free;
 end;
end;

end.
